Function IgnoreFolder:Int(Path:String)
	Local Name:String = StripDir(Path)
	
	If Name[0] = "."[0] Then Return True
End Function

Function FindRelativePath:String(A:String, B:String)
	A = ExtractDir(A) + "/"
	
	Local I:Int = 0
	While I < A.Length And A[I] = B[I]
		I :+ 1
	Wend
	
	Local Prefix:String
	For Local T:Int = I Until A.Length
		If A[T] = "/"[0] Or A[T] = "\"[0] Then Prefix :+ "../"
	Next
	
	Return Prefix + B[I ..].Replace("\", "/")
End Function

Function GetAbsolutePath:String(Path:String)
	'Check if we got an absolute path here
	Local IsAbsolutePath:Byte = False
	?Win32

		'Convert windows style path
		Path = Path.Replace("\", "/")

		'Windows network resources start with //
		If Path.StartsWith("//") Then
			IsAbsolutePath = True
		Else
			Local i:Int = Path.Find(":")
			If i <> -1 And Chr(Path[i+1]) = "/" Then
				IsAbsolutePath = True
			EndIf
		EndIf

	?Not Win32

		IsAbsolutePath = (Chr(Path[0]) = "/")

		'Allow protocol URIs like http://, ftp:// etc
		If Not IsAbsolutePath Then
			Local i:Int = Path.Find(":")
			If i <> -1 And Path[i+1..i+2] = "//" Then
				IsAbsolutePath = True
			EndIf
		EndIf

	?

	'If we got a relative path, make it absolute!
	If Not IsAbsolutePath Then
		'CurrentDir returns the path of the compiler binary
		'what we need is the path the user is calling the compiler from
		
		If LaunchDir.EndsWith("BlitzMax") Then 'HACK Allow launch from BMax-IDE
			Path = RealPath(Path)
		Else
			Path = RealPath(LaunchDir + "/" + Path)
		EndIf
	EndIf

	Return Path
End Function