SuperStrict

'TODO: = For strings
'TODO: Protected and proper visibility rules
'TODO: Interfaces
'TODO: Use namespaces for modules to enforce symbol resolution
'TODO: +=, /= etc.
'TODO: Revisit  keyword list in TLexer
'TODO: Revisit *.dep parsing
'TODO: Expression list in Select/Case
'TODO: Rethink Const/Global visibility
'TODO: Rewrite Lexer
'<FireballFlame> kommt, wenn die schreibweise nach New anders ist als in der klassendeklaration
'<BladeRunner> wenn ich If a=b Then Print("identisch") mache.
'<BladeRunner> Local a:String = "blub"
'<BladeRunner> Local obj:Object=Object(a)
'<BladeRunner> Print(String(obj))
'<BladeRunner> c'est ca.

Import "BismuthParser.tab.c"
Import "FileUtil.bmx"
Import "StringUtil.bmx"
Import "Constants.bmx"

Const START_LINE:Int = 0
Const START_COL :Int = 1
Const END_LINE  :Int = 2
Const END_COL   :Int = 3

Const CONF_OUTPUT:Int    = 0
Const CONF_DEBUG:Int     = 1
Const CONF_HELP:Int      = 2
Const CONF_EXECUTE:Int   = 3
Const CONF_RECOMPILE:Int = 4
Const CONF_TARGET:Int    = 5
Const CONF_MODULE:Int    = 6

Include "Compiler.bmx"
Include "Lexer.bmx"
Include "AST.bmx"
Include "CLI.bmx"
Include "target/CPP.bmx"
Include "Module.bmx"
Include "CPPWriter.bmx"

Global c:CLI = New CLI
'Add a few command line arguments
c.AddArgument(CLIArgument.Create("o", "output", "Specifies output file name", 1, True, "a.out", CONF_OUTPUT))
c.AddArgument(CLIArgument.Create("d", "debug", "Enables debug mode", 0, True, "", CONF_DEBUG))
c.AddArgument(CLIArgument.Create("h", "help", "Displays this information", 0, True, "", CONF_HELP))
c.AddArgument(CLIArgument.Create("x", "execute", "Execute the program after compilation", 0, True, "", CONF_EXECUTE))
c.AddArgument(CLIArgument.Create("r", "recompile", "Forces complete recompilation", 0, True, "", CONF_RECOMPILE))
c.AddArgument(CLIArgument.Create("t", "target", "Select a target language", 1, True, "cpp", CONF_TARGET))
c.AddArgument(CLIArgument.Create("m", "module", "Compile a specific module", 0, True, "", CONF_MODULE))

SeedRnd MilliSecs() 'Required for include guard generation

'Do the parsing
Local ret:Int = c.ParseCommandLine(AppArgs)

'Display usage information on command line error or --help-switch
If (c.Config[CONF_HELP] = "on") Or ret = False Then
	Print c.GetUsageDescription()
	End
EndIf

'Convert output path to absolute path (if not already)
c.Config[CONF_OUTPUT] = GetAbsolutePath(c.Config[CONF_OUTPUT])

Local Compiler:TCompiler = New TCompiler

'Check if the user wants to compile a module
If c.Config[CONF_MODULE] = "on" Then
	Local ModuleList:TList = TModule.ListModulesInScope(c.InputFile)
	
	If ModuleList.IsEmpty() Then
		Print("No matching modules found for '" + c.InputFile + "'")
		Return
	EndIf

	For Local CodePath:String = EachIn ModuleList
		Compiler.Setup(c.Config, CodePath)
		Compiler.Parse()
		Compiler.GenerateDependenciesFile(Compiler.ASTRoot, Compiler.GenerateModuleTargetPath(CodePath) + ".dep")
	Next
	
	TCompiler.ModuleTree   = New TModule.Load(Null, "")
	TCompiler.BismuthScope = Compiler.CheckModuleScope(Null, Compiler.LoadModules("Bismuth.*",,, True))
	
	For Local CodePath:String = EachIn ModuleList
		Compiler.Setup(c.Config, CodePath)
		Compiler.Parse()
		Compiler.SemanticAnalysis()
		Compiler.GenerateHeaderFiles()
	Next
	
	For Local CodePath:String = EachIn ModuleList
		Compiler.Setup(c.Config, CodePath)
		Compiler.Parse()
		Compiler.SemanticAnalysis()
		Compiler.Compile()
	Next
Else
	Compiler.Setup(c.Config, c.InputFile)
	
	TCompiler.ModuleTree   = New TModule.Load(Null, "")
	TCompiler.BismuthScope = Compiler.CheckModuleScope(Null, Compiler.LoadModules("Bismuth.*",,, True))
	
	Compiler.Parse()
	Compiler.SemanticAnalysis()
	Compiler.GenerateHeaderFiles()
	Compiler.Compile()
EndIf

StandardIOStream.Flush()

End
