#include "List.h"
#include "ClassListLink.h"
#include "ClassListIterator.h"
#include "ClassList.h"
void ListLink::Remove(){
	Value = 0;
	Unlink();
};
void ListLink::Unlink(){
	(Succ)->Pred = Pred;
	(Pred)->Succ = Succ;
};
void ListLink::InsertBefore(ListLink* Other){
	((Other)->Pred)->Succ = this;
	Pred = (Other)->Pred;
	(Other)->Pred = this;
	Succ = Other;
};
void ListLink::InsertAfter(ListLink* Other){
	InsertBefore((Other)->Succ);
};
ListLink* ListLink::__CreateListLink(Object* Value, ListLink* Pred, ListLink* Succ){
	if (((((Value == 0)) && ((Pred == 0))) && ((Succ == 0)))){
		Value = (this);
	};
	if ((Pred == 0)){
		Pred = this;
	};
	if ((Succ == 0)){
		Succ = this;
	};
	(this)->Value = Value;
	(this)->Pred = Pred;
	(this)->Succ = Succ;
	(Pred)->Succ = this;
	(Succ)->Pred = this;
	return this;
};
ListLink::ListLink(){
	Value = 0;
	Pred = 0;
	Succ = 0;
};
bool ListIterator::HasNext(){
	return ((CurrentLink)->Value != CurrentLink);
};
Object* ListIterator::GetNext(){
	Object* Value = (CurrentLink)->Value;
	CurrentLink = (CurrentLink)->Succ;
	return Value;
};
ListIterator* ListIterator::__CreateListIterator(List* Liste){
	CurrentLink = ((Liste)->Head)->Succ;
	return this;
};
ListIterator::ListIterator(){
	CurrentLink = 0;
};
Object* List::_EachIn(){
	if ((__eachiniterator == 0)){
		Print(new String("Iterator erschaffen!"));
		__eachiniterator = GetIterator();
	};
	if ((__eachiniterator)->HasNext()){
		Print(new String("es sind noch Objekte in der Liste"));
		return (__eachiniterator)->GetNext();
	} else {
		Print(new String("Fertig"));
		__eachiniterator = 0;
		return 0;
	};
	return 0;
};
void List::Sort(bool Descending, int32_t (*CompareFunc) (Object*, Object*)){
	int32_t SortSign = (1 - (Descending * 2));
	do {
		ListLink* MergePoint = (Head)->Succ;
		while ((MergePoint != Head)){
			ListLink* MergeHead = MergePoint;
			while (((MergePoint)->Succ != Head)){
				MergePoint = (MergePoint)->Succ;
				if (((CompareFunc(((MergePoint)->Pred)->Value, (MergePoint)->Value) * SortSign) > 0)){
					break;
				};
			};
			if ((((MergeHead)->Pred == Head) && ((MergePoint)->Succ == Head))){
				return ;
			};
			ListLink* MergeTail = MergePoint;
			do {
				if (((CompareFunc((MergeHead)->Value, (MergeTail)->Value) * SortSign) > 0)){
					ListLink* NextTail = (MergeTail)->Succ;
					(MergeTail)->Unlink();
					(MergeTail)->InsertBefore(MergeHead);
					if (((NextTail != Head) && ((CompareFunc((MergeTail)->Value, (NextTail)->Value) * SortSign) <= 0))){
						MergeTail = NextTail;
					} else {
						MergePoint = NextTail;
						break;
					};
				} else {
					if (((((MergeHead)->Succ != Head) && ((MergeHead)->Succ != MergeTail)) && ((CompareFunc((MergeHead)->Value, ((MergeHead)->Succ)->Value) * SortSign) <= 0))){
						MergeHead = (MergeHead)->Succ;
					} else {
						MergePoint = (MergeTail)->Succ;
						break;
					};
				};
			}while(1);
		};
	}while(1);
};
void List::Clear(){
	while (((Head)->Succ != Head)){
		((Head)->Succ)->Remove();
	};
};
bool List::IsEmpty(){
	return ((Head)->Succ == Head);
};
Object* List::First(){
	if (IsEmpty()){
		return 0;
	} else {
		return ((Head)->Succ)->Value;
	};
	return 0;
};
Object* List::Last(){
	if (IsEmpty()){
		return 0;
	} else {
		return ((Head)->Pred)->Value;
	};
	return 0;
};
void List::Remove(Object* Value){
	ListLink* Link = (Head)->Succ;
	while ((Link != Head)){
		if (((Link)->Value == Value)){
			(Link)->Remove();
			return ;
		};
		Link = (Link)->Succ;
	};
};
Object* List::RemoveFirst(){
	if (IsEmpty()){
		return 0;
	};
	Object* Result = ((Head)->Succ)->Value;
	((Head)->Succ)->Remove();
	return Result;
};
Object* List::RemoveLast(){
	if (IsEmpty()){
		return 0;
	};
	Object* Result = ((Head)->Pred)->Value;
	((Head)->Pred)->Remove();
	return Result;
};
void List::AddFirst(Object* Value){
	AddAfter(Value, Head);
};
void List::AddLast(Object* Value){
	AddBefore(Value, Head);
};
ListLink* List::AddBefore(Object* Value, ListLink* Link){
	return ((new ListLink))->__CreateListLink(Value, (Link)->Pred, Link);
};
ListLink* List::AddAfter(Object* Value, ListLink* Link){
	return ((new ListLink))->__CreateListLink(Value, Link, (Link)->Succ);
};
Iterator* List::GetIterator(){
	return (((new ListIterator))->__CreateListIterator(this));
};
List* List::__CreateList(){
	Head = ((new ListLink))->__CreateListLink((Head), Head, Head);
	return this;
};
List::List(){
	Head = 0;
	__eachiniterator = 0;
};
void ListMain(){
}