Class ListLink
    Field Value:Object
    
    Field Pred:ListLink
    Field Succ:ListLink
    
    Method Remove()
        Value = Null
        Unlink()
    End Method
    
    Method Unlink()
        Succ.Pred = Pred
        Pred.Succ = Succ
    End Method
    
    Method InsertBefore(Other:ListLink)
        Other.Pred.Succ = Self
        Pred = Other.Pred
        Other.Pred = Self
        Succ = Other
    End Method
    
    Method InsertAfter(Other:ListLink)
        InsertBefore(Other.Succ)
    End Method
    
    Method ListLink(Value:Object, Pred:ListLink, Succ:ListLink)

        if (value=null) and (pred = null) and (succ=null) then
            value = self
        endif
        if pred = null then
            pred = self
        endif
        
        if succ = null then 
            succ=self
        endif
        
        Self.Value = Value
        Self.Pred  = Pred
        Self.Succ  = Succ

        Pred.Succ = self
        Succ.Pred = self
        //Return Self
    End Method
End Class

Class ListIterator extends Iterator
    Field CurrentLink:ListLink
    
    Method HasNext:Bool()
        Return CurrentLink.Value <> CurrentLink
    End Method
    
    Method GetNext:Object()
        Local Value:Object = CurrentLink.Value
        
        CurrentLink = CurrentLink.Succ
        
        Return Value
    End Method
    
    Method ListIterator(Liste:List)
        CurrentLink = Liste.Head.Succ
        
        //Return Self
    End Method
End Class

Class List extends Container
	Field Head:ListLink
    Field __eachiniterator:Iterator
    Method _EachIn:Object()
    
    if __eachiniterator = Null then
        print("Iterator erschaffen!")
        __eachiniterator = GetIterator()
    endif
    if __eachiniterator.hasnext() then
        print("es sind noch Objekte in der Liste")
        return __eachiniterator.getnext()
    else
        Print("Fertig")
        __eachiniterator = null
        return Null
    endif
    EndMethod
    
    Method Sort(Descending:Bool, CompareFunc:Int(A:Object, B:Object))
        Local SortSign:Int = 1 - Descending*2
        Repeat
            Local MergePoint:ListLink = Head.Succ
            
            While MergePoint <> Head
                Local MergeHead:ListLink = MergePoint
                
                While MergePoint.Succ <> Head
                    MergePoint = MergePoint.Succ
                    
                    If CompareFunc(MergePoint.Pred.Value, MergePoint.Value)*SortSign > 0 Then Exit
                Wend
                
                If MergeHead.Pred = Head And MergePoint.Succ = Head Then Return
                
                Local MergeTail:ListLink = MergePoint
                Repeat
                    If CompareFunc(MergeHead.Value, MergeTail.Value)*SortSign > 0 Then
                        Local NextTail:ListLink = MergeTail.Succ
                        
                        MergeTail.Unlink()
                        MergeTail.InsertBefore(MergeHead)
                        
                        If NextTail <> Head And CompareFunc(MergeTail.Value, NextTail.Value)*SortSign <= 0 Then
                            MergeTail = NextTail
                        Else
                            MergePoint = NextTail
                            Exit
                        EndIf
                    Else
                        If MergeHead.Succ <> Head And MergeHead.Succ <> MergeTail And CompareFunc(MergeHead.Value, MergeHead.Succ.Value)*SortSign <= 0 Then
                            MergeHead = MergeHead.Succ
                        Else
                            MergePoint = MergeTail.Succ
                            Exit
                        EndIf
                    EndIf
                Forever
            Wend
        Forever
    End Method
    
    Method Clear()
        While Head.Succ <> Head
            Head.Succ.Remove()
        Wend
    End Method
    
    Method IsEmpty:Bool()
        Return Head.Succ = Head
    End Method
    
    Method First:Object()
        If IsEmpty() Then Return Null Else Return Head.Succ.Value
    End Method
    
    Method Last:Object()
        If IsEmpty() Then Return Null Else Return Head.Pred.Value
    End Method
    
    Method Remove(Value:Object)
        Local Link:ListLink = Head.Succ
        While Link <> Head
            If Link.Value = Value Then
                Link.Remove()
                Return
            Endif
            
            Link = Link.Succ
        Wend
    End Method
    
    Method RemoveFirst:Object()
        If IsEmpty() Then Return Null
        
        Local Result:Object = Head.Succ.Value
        Head.Succ.Remove()
        
        Return Result
    End Method
    
    Method RemoveLast:Object()
        If IsEmpty() Then Return Null
        
        Local Result:Object = Head.Pred.Value
        Head.Pred.Remove()
        
        Return Result
    End Method
    
    Method AddFirst(Value:Object)
		AddAfter(Value, Head)
	End Method

	Method AddLast(Value:Object)
		AddBefore(Value, Head)
	End Method
    
    Method AddBefore:ListLink(Value:Object, Link:ListLink)
        Return New ListLink(Value, Link.Pred, Link)
    End Method
    
    Method AddAfter:ListLink(Value:Object, Link:ListLink)
        Return New ListLink(Value, Link, Link.Succ)
    End Method
    
    Method GetIterator:Iterator()
        Return New ListIterator(Self)
    End Method

	Method List()
		
        Head = New ListLink(Head, Head, Head)
        //Head.Create(Head, Head, Head)

		//Return Self
	End Method
EndClass 

