#ifndef BISMUTH_CORE_STRING
#define BISMUTH_CORE_STRING

#include "Bismuth/Core/Array/Array.h"
#include "Bismuth/Core/Object/Object.h"

struct String : public Object {
	int Length;
	char* Data;
	
	String(const char* pData);
	String(char* pData, int pLength) : Length(pLength), Data(pData) { };
    
    String* Prepend(char* Buffer);
    String*  Append(char* Buffer);

	String* Append (char* Buffer, int Size);
	String* Prepend(char* Buffer, int Size);
	String* Append (String* Other);
	String* Prepend(String* Other);
	String* Append (bool Other);
	String* Prepend(bool Other);
	String* Append (short Other);
	String* Prepend(short Other);
	String* Append (int Other);
	String* Prepend(int Other);
	String* Append (long long int Other);
	String* Prepend(long long int Other);
	String* Append (size_t Other);
	String* Prepend(size_t Other);
	String* Append (float Other);
	String* Prepend(float Other);
	String* Append (double Other);
	String* Prepend(double Other);

    bool Equals(String* Other);
    
	String* Part(int From, int To);
	int Find(String* Search, int From = 0);
 	int FindLast(String* Substring, int From);
	String* Replace(String* Search, String* Replacement);
    
	String* TrimLead();
	String* TrimTrail();
	String* Trim();
    
	int       ToInt();
	float   ToFloat();
	String* ToUpper();
	String* ToLower();
    char* ToCString();
    String* Reverse();
    
	int StartsWith(String* Substring);
	int EndsWith(String* Substring);
	int Contains(String* Substring);
    
    Array<String*,1>* Split(String* Separator);
	int CountOccurrences(String* Substring);
    
    static	String* FromChar(int Code);
    static	String* FromCString(char* CString);
    static	String* FromCString(const char* CString);
    static	String* FromBytes(Array<char, 1>* Bytes,int Count);
    static	String* Hex(int Number);
    static	String* Bin(int Number);
    static	String* Oct(int Number);
};

#endif
