Import "OpenGL.h"
Import "opengl32"

Extern

/************************************************************************
 *
 * Constants
 *
 ************************************************************************/

/* Boolean values */
Const GL_FALSE:Int
Const GL_TRUE:Int

/* Data types */
Const GL_BYTE:Int
Const GL_UNSIGNED_BYTE:Int
Const GL_SHORT:Int
Const GL_UNSIGNED_SHORT:Int
Const GL_INT:Int
Const GL_UNSIGNED_INT:Int
Const GL_FLOAT:Int
Const GL_DOUBLE:Int
Const GL_2_BYTES:Int
Const GL_3_BYTES:Int
Const GL_4_BYTES:Int

/* Primitives */
Const GL_POINTS:Int
Const GL_LINES:Int
Const GL_LINE_LOOP:Int
Const GL_LINE_STRIP:Int
Const GL_TRIANGLES:Int
Const GL_TRIANGLE_STRIP:Int
Const GL_TRIANGLE_FAN:Int
Const GL_QUADS:Int
Const GL_QUAD_STRIP:Int
Const GL_POLYGON:Int

/* Vertex Arrays */
Const GL_VERTEX_ARRAY:Int
Const GL_NORMAL_ARRAY:Int
Const GL_COLOR_ARRAY:Int
Const GL_INDEX_ARRAY:Int
Const GL_TEXTURE_COORD_ARRAY:Int
Const GL_EDGE_FLAG_ARRAY:Int
Const GL_VERTEX_ARRAY_SIZE:Int
Const GL_VERTEX_ARRAY_TYPE:Int
Const GL_VERTEX_ARRAY_STRIDE:Int
Const GL_NORMAL_ARRAY_TYPE:Int
Const GL_NORMAL_ARRAY_STRIDE:Int
Const GL_COLOR_ARRAY_SIZE:Int
Const GL_COLOR_ARRAY_TYPE:Int
Const GL_COLOR_ARRAY_STRIDE:Int
Const GL_INDEX_ARRAY_TYPE:Int
Const GL_INDEX_ARRAY_STRIDE:Int
Const GL_TEXTURE_COORD_ARRAY_SIZE:Int
Const GL_TEXTURE_COORD_ARRAY_TYPE:Int
Const GL_TEXTURE_COORD_ARRAY_STRIDE:Int
Const GL_EDGE_FLAG_ARRAY_STRIDE:Int
Const GL_VERTEX_ARRAY_POINTER:Int
Const GL_NORMAL_ARRAY_POINTER:Int
Const GL_COLOR_ARRAY_POINTER:Int
Const GL_INDEX_ARRAY_POINTER:Int
Const GL_TEXTURE_COORD_ARRAY_POINTER:Int
Const GL_EDGE_FLAG_ARRAY_POINTER:Int
Const GL_V2F:Int
Const GL_V3F:Int
Const GL_C4UB_V2F:Int
Const GL_C4UB_V3F:Int
Const GL_C3F_V3F:Int
Const GL_N3F_V3F:Int
Const GL_C4F_N3F_V3F:Int
Const GL_T2F_V3F:Int
Const GL_T4F_V4F:Int
Const GL_T2F_C4UB_V3F:Int
Const GL_T2F_C3F_V3F:Int
Const GL_T2F_N3F_V3F:Int
Const GL_T2F_C4F_N3F_V3F:Int
Const GL_T4F_C4F_N3F_V4F:Int

/* Matrix Mode */
Const GL_MATRIX_MODE:Int
Const GL_MODELVIEW:Int
Const GL_PROJECTION:Int
Const GL_TEXTURE:Int

/* Points */
Const GL_POINT_SMOOTH:Int
Const GL_POINT_SIZE:Int
Const GL_POINT_SIZE_GRANULARITY:Int
Const GL_POINT_SIZE_RANGE:Int

/* Lines */
Const GL_LINE_SMOOTH:Int
Const GL_LINE_STIPPLE:Int
Const GL_LINE_STIPPLE_PATTERN:Int
Const GL_LINE_STIPPLE_REPEAT:Int
Const GL_LINE_WIDTH:Int
Const GL_LINE_WIDTH_GRANULARITY:Int
Const GL_LINE_WIDTH_RANGE:Int

/* Polygons */
Const GL_POINT:Int
Const GL_LINE:Int
Const GL_FILL:Int
Const GL_CW:Int
Const GL_CCW:Int
Const GL_FRONT:Int
Const GL_BACK:Int
Const GL_POLYGON_MODE:Int
Const GL_POLYGON_SMOOTH:Int
Const GL_POLYGON_STIPPLE:Int
Const GL_EDGE_FLAG:Int
Const GL_CULL_FACE:Int
Const GL_CULL_FACE_MODE:Int
Const GL_FRONT_FACE:Int
Const GL_POLYGON_OFFSET_FACTOR:Int
Const GL_POLYGON_OFFSET_UNITS:Int
Const GL_POLYGON_OFFSET_POINT:Int
Const GL_POLYGON_OFFSET_LINE:Int
Const GL_POLYGON_OFFSET_FILL:Int

/* Display Lists */
Const GL_COMPILE:Int
Const GL_COMPILE_AND_EXECUTE:Int
Const GL_LIST_BASE:Int
Const GL_LIST_INDEX:Int
Const GL_LIST_MODE:Int

/* Depth buffer */
Const GL_NEVER:Int
Const GL_LESS:Int
Const GL_EQUAL:Int
Const GL_LEQUAL:Int
Const GL_GREATER:Int
Const GL_NOTEQUAL:Int
Const GL_GEQUAL:Int
Const GL_ALWAYS:Int
Const GL_DEPTH_TEST:Int
Const GL_DEPTH_BITS:Int
Const GL_DEPTH_CLEAR_VALUE:Int
Const GL_DEPTH_FUNC:Int
Const GL_DEPTH_RANGE:Int
Const GL_DEPTH_WRITEMASK:Int
Const GL_DEPTH_COMPONENT:Int

/* Lighting */
Const GL_LIGHTING:Int
Const GL_LIGHT0:Int
Const GL_LIGHT1:Int
Const GL_LIGHT2:Int
Const GL_LIGHT3:Int
Const GL_LIGHT4:Int
Const GL_LIGHT5:Int
Const GL_LIGHT6:Int
Const GL_LIGHT7:Int
Const GL_SPOT_EXPONENT:Int
Const GL_SPOT_CUTOFF:Int
Const GL_CONSTANT_ATTENUATION:Int
Const GL_LINEAR_ATTENUATION:Int
Const GL_QUADRATIC_ATTENUATION:Int
Const GL_AMBIENT:Int
Const GL_DIFFUSE:Int
Const GL_SPECULAR:Int
Const GL_SHININESS:Int
Const GL_EMISSION:Int
Const GL_POSITION:Int
Const GL_SPOT_DIRECTION:Int
Const GL_AMBIENT_AND_DIFFUSE:Int
Const GL_COLOR_INDEXES:Int
Const GL_LIGHT_MODEL_TWO_SIDE:Int
Const GL_LIGHT_MODEL_LOCAL_VIEWER:Int
Const GL_LIGHT_MODEL_AMBIENT:Int
Const GL_FRONT_AND_BACK:Int
Const GL_SHADE_MODEL:Int
Const GL_FLAT:Int
Const GL_SMOOTH:Int
Const GL_COLOR_MATERIAL:Int
Const GL_COLOR_MATERIAL_FACE:Int
Const GL_COLOR_MATERIAL_PARAMETER:Int
Const GL_NORMALIZE:Int

/* User clipping planes */
Const GL_CLIP_PLANE0:Int
Const GL_CLIP_PLANE1:Int
Const GL_CLIP_PLANE2:Int
Const GL_CLIP_PLANE3:Int
Const GL_CLIP_PLANE4:Int
Const GL_CLIP_PLANE5:Int

/* Accumulation buffer */
Const GL_ACCUM_RED_BITS:Int
Const GL_ACCUM_GREEN_BITS:Int
Const GL_ACCUM_BLUE_BITS:Int
Const GL_ACCUM_ALPHA_BITS:Int
Const GL_ACCUM_CLEAR_VALUE:Int
Const GL_ACCUM:Int
Const GL_ADD:Int
Const GL_LOAD:Int
Const GL_MULT:Int
Const GL_RETURN:Int

/* Alpha testing */
Const GL_ALPHA_TEST:Int
Const GL_ALPHA_TEST_REF:Int
Const GL_ALPHA_TEST_FUNC:Int

/* Blending */
Const GL_BLEND:Int
Const GL_BLEND_SRC:Int
Const GL_BLEND_DST:Int
Const GL_ZERO:Int
Const GL_ONE:Int
Const GL_SRC_COLOR:Int
Const GL_ONE_MINUS_SRC_COLOR:Int
Const GL_SRC_ALPHA:Int
Const GL_ONE_MINUS_SRC_ALPHA:Int
Const GL_DST_ALPHA:Int
Const GL_ONE_MINUS_DST_ALPHA:Int
Const GL_DST_COLOR:Int
Const GL_ONE_MINUS_DST_COLOR:Int
Const GL_SRC_ALPHA_SATURATE:Int
Const GL_CONSTANT_COLOR:Int
Const GL_ONE_MINUS_CONSTANT_COLOR:Int
Const GL_CONSTANT_ALPHA:Int
Const GL_ONE_MINUS_CONSTANT_ALPHA:Int

/* Render Mode */
Const GL_FEEDBACK:Int
Const GL_RENDER:Int
Const GL_SELECT:Int

/* Feedback */
Const GL_2D:Int
Const GL_3D:Int
Const GL_3D_COLOR:Int
Const GL_3D_COLOR_TEXTURE:Int
Const GL_4D_COLOR_TEXTURE:Int
Const GL_POINT_TOKEN:Int
Const GL_LINE_TOKEN:Int
Const GL_LINE_RESET_TOKEN:Int
Const GL_POLYGON_TOKEN:Int
Const GL_BITMAP_TOKEN:Int
Const GL_DRAW_PIXEL_TOKEN:Int
Const GL_COPY_PIXEL_TOKEN:Int
Const GL_PASS_THROUGH_TOKEN:Int
Const GL_FEEDBACK_BUFFER_POINTER:Int
Const GL_FEEDBACK_BUFFER_SIZE:Int
Const GL_FEEDBACK_BUFFER_TYPE:Int

/* Selection */
Const GL_SELECTION_BUFFER_POINTER:Int
Const GL_SELECTION_BUFFER_SIZE:Int

/* Fog */
Const GL_FOG:Int
Const GL_FOG_MODE:Int
Const GL_FOG_DENSITY:Int
Const GL_FOG_COLOR:Int
Const GL_FOG_INDEX:Int
Const GL_FOG_START:Int
Const GL_FOG_END:Int
Const GL_LINEAR:Int
Const GL_EXP:Int
Const GL_EXP2:Int

/* Logic Ops */
Const GL_LOGIC_OP:Int
Const GL_INDEX_LOGIC_OP:Int
Const GL_COLOR_LOGIC_OP:Int
Const GL_LOGIC_OP_MODE:Int
Const GL_CLEAR:Int
Const GL_SET:Int
Const GL_COPY:Int
Const GL_COPY_INVERTED:Int
Const GL_NOOP:Int
Const GL_INVERT:Int
Const GL_AND:Int
Const GL_NAND:Int
Const GL_OR:Int
Const GL_NOR:Int
Const GL_XOR:Int
Const GL_EQUIV:Int
Const GL_AND_REVERSE:Int
Const GL_AND_INVERTED:Int
Const GL_OR_REVERSE:Int
Const GL_OR_INVERTED:Int

/* Stencil */
Const GL_STENCIL_TEST:Int
Const GL_STENCIL_WRITEMASK:Int
Const GL_STENCIL_BITS:Int
Const GL_STENCIL_FUNC:Int
Const GL_STENCIL_VALUE_MASK:Int
Const GL_STENCIL_REF:Int
Const GL_STENCIL_FAIL:Int
Const GL_STENCIL_PASS_DEPTH_PASS:Int
Const GL_STENCIL_PASS_DEPTH_FAIL:Int
Const GL_STENCIL_CLEAR_VALUE:Int
Const GL_STENCIL_INDEX:Int
Const GL_KEEP:Int
Const GL_REPLACE:Int
Const GL_INCR:Int
Const GL_DECR:Int

/* Buffers, Pixel Drawing/Reading */
Const GL_NONE:Int
Const GL_LEFT:Int
Const GL_RIGHT:Int
/*GL_FRONT:Int */
/*GL_BACK:Int */
/*GL_FRONT_AND_BACK:Int */
Const GL_FRONT_LEFT:Int
Const GL_FRONT_RIGHT:Int
Const GL_BACK_LEFT:Int
Const GL_BACK_RIGHT:Int
Const GL_AUX0:Int
Const GL_AUX1:Int
Const GL_AUX2:Int
Const GL_AUX3:Int
Const GL_COLOR_INDEX:Int
Const GL_RED:Int
Const GL_GREEN:Int
Const GL_BLUE:Int
Const GL_ALPHA:Int
Const GL_LUMINANCE:Int
Const GL_LUMINANCE_ALPHA:Int
Const GL_ALPHA_BITS:Int
Const GL_RED_BITS:Int
Const GL_GREEN_BITS:Int
Const GL_BLUE_BITS:Int
Const GL_INDEX_BITS:Int
Const GL_SUBPIXEL_BITS:Int
Const GL_AUX_BUFFERS:Int
Const GL_READ_BUFFER:Int
Const GL_DRAW_BUFFER:Int
Const GL_DOUBLEBUFFER:Int
Const GL_STEREO:Int
Const GL_BITMAP:Int
Const GL_COLOR:Int
Const GL_DEPTH:Int
Const GL_STENCIL:Int
Const GL_DITHER:Int
Const GL_RGB:Int
Const GL_RGBA:Int

/* Implementation limits */
Const GL_MAX_LIST_NESTING:Int
Const GL_MAX_ATTRIB_STACK_DEPTH:Int
Const GL_MAX_MODELVIEW_STACK_DEPTH:Int
Const GL_MAX_NAME_STACK_DEPTH:Int
Const GL_MAX_PROJECTION_STACK_DEPTH:Int
Const GL_MAX_TEXTURE_STACK_DEPTH:Int
Const GL_MAX_EVAL_ORDER:Int
Const GL_MAX_LIGHTS:Int
Const GL_MAX_CLIP_PLANES:Int
Const GL_MAX_TEXTURE_SIZE:Int
Const GL_MAX_PIXEL_MAP_TABLE:Int
Const GL_MAX_VIEWPORT_DIMS:Int
Const GL_MAX_CLIENT_ATTRIB_STACK_DEPTH:Int

/* Gets */
Const GL_ATTRIB_STACK_DEPTH:Int
Const GL_CLIENT_ATTRIB_STACK_DEPTH:Int
Const GL_COLOR_CLEAR_VALUE:Int
Const GL_COLOR_WRITEMASK:Int
Const GL_CURRENT_INDEX:Int
Const GL_CURRENT_COLOR:Int
Const GL_CURRENT_NORMAL:Int
Const GL_CURRENT_RASTER_COLOR:Int
Const GL_CURRENT_RASTER_DISTANCE:Int
Const GL_CURRENT_RASTER_INDEX:Int
Const GL_CURRENT_RASTER_POSITION:Int
Const GL_CURRENT_RASTER_TEXTURE_COORDS:Int
Const GL_CURRENT_RASTER_POSITION_VALID:Int
Const GL_CURRENT_TEXTURE_COORDS:Int
Const GL_INDEX_CLEAR_VALUE:Int
Const GL_INDEX_MODE:Int
Const GL_INDEX_WRITEMASK:Int
Const GL_MODELVIEW_MATRIX:Int
Const GL_MODELVIEW_STACK_DEPTH:Int
Const GL_NAME_STACK_DEPTH:Int
Const GL_PROJECTION_MATRIX:Int
Const GL_PROJECTION_STACK_DEPTH:Int
Const GL_RENDER_MODE:Int
Const GL_RGBA_MODE:Int
Const GL_TEXTURE_MATRIX:Int
Const GL_TEXTURE_STACK_DEPTH:Int
Const GL_VIEWPORT:Int

/* Evaluators */
Const GL_AUTO_NORMAL:Int
Const GL_MAP1_COLOR_4:Int
Const GL_MAP1_GRID_DOMAIN:Int
Const GL_MAP1_GRID_SEGMENTS:Int
Const GL_MAP1_INDEX:Int
Const GL_MAP1_NORMAL:Int
Const GL_MAP1_TEXTURE_COORD_1:Int
Const GL_MAP1_TEXTURE_COORD_2:Int
Const GL_MAP1_TEXTURE_COORD_3:Int
Const GL_MAP1_TEXTURE_COORD_4:Int
Const GL_MAP1_VERTEX_3:Int
Const GL_MAP1_VERTEX_4:Int
Const GL_MAP2_COLOR_4:Int
Const GL_MAP2_GRID_DOMAIN:Int
Const GL_MAP2_GRID_SEGMENTS:Int
Const GL_MAP2_INDEX:Int
Const GL_MAP2_NORMAL:Int
Const GL_MAP2_TEXTURE_COORD_1:Int
Const GL_MAP2_TEXTURE_COORD_2:Int
Const GL_MAP2_TEXTURE_COORD_3:Int
Const GL_MAP2_TEXTURE_COORD_4:Int
Const GL_MAP2_VERTEX_3:Int
Const GL_MAP2_VERTEX_4:Int
Const GL_COEFF:Int
Const GL_DOMAIN:Int
Const GL_ORDER:Int

/* Hints */
Const GL_FOG_HINT:Int
Const GL_LINE_SMOOTH_HINT:Int
Const GL_PERSPECTIVE_CORRECTION_HINT:Int
Const GL_POINT_SMOOTH_HINT:Int
Const GL_POLYGON_SMOOTH_HINT:Int
Const GL_DONT_CARE:Int
Const GL_FASTEST:Int
Const GL_NICEST:Int

/* Scissor box */
Const GL_SCISSOR_TEST:Int
Const GL_SCISSOR_BOX:Int

/* Pixel Mode / Transfer */
Const GL_MAP_COLOR:Int
Const GL_MAP_STENCIL:Int
Const GL_INDEX_SHIFT:Int
Const GL_INDEX_OFFSET:Int
Const GL_RED_SCALE:Int
Const GL_RED_BIAS:Int
Const GL_GREEN_SCALE:Int
Const GL_GREEN_BIAS:Int
Const GL_BLUE_SCALE:Int
Const GL_BLUE_BIAS:Int
Const GL_ALPHA_SCALE:Int
Const GL_ALPHA_BIAS:Int
Const GL_DEPTH_SCALE:Int
Const GL_DEPTH_BIAS:Int
Const GL_PIXEL_MAP_S_TO_S_SIZE:Int
Const GL_PIXEL_MAP_I_TO_I_SIZE:Int
Const GL_PIXEL_MAP_I_TO_R_SIZE:Int
Const GL_PIXEL_MAP_I_TO_G_SIZE:Int
Const GL_PIXEL_MAP_I_TO_B_SIZE:Int
Const GL_PIXEL_MAP_I_TO_A_SIZE:Int
Const GL_PIXEL_MAP_R_TO_R_SIZE:Int
Const GL_PIXEL_MAP_G_TO_G_SIZE:Int
Const GL_PIXEL_MAP_B_TO_B_SIZE:Int
Const GL_PIXEL_MAP_A_TO_A_SIZE:Int
Const GL_PIXEL_MAP_S_TO_S:Int
Const GL_PIXEL_MAP_I_TO_I:Int
Const GL_PIXEL_MAP_I_TO_R:Int
Const GL_PIXEL_MAP_I_TO_G:Int
Const GL_PIXEL_MAP_I_TO_B:Int
Const GL_PIXEL_MAP_I_TO_A:Int
Const GL_PIXEL_MAP_R_TO_R:Int
Const GL_PIXEL_MAP_G_TO_G:Int
Const GL_PIXEL_MAP_B_TO_B:Int
Const GL_PIXEL_MAP_A_TO_A:Int
Const GL_PACK_ALIGNMENT:Int
Const GL_PACK_LSB_FIRST:Int
Const GL_PACK_ROW_LENGTH:Int
Const GL_PACK_SKIP_PIXELS:Int
Const GL_PACK_SKIP_ROWS:Int
Const GL_PACK_SWAP_BYTES:Int
Const GL_UNPACK_ALIGNMENT:Int
Const GL_UNPACK_LSB_FIRST:Int
Const GL_UNPACK_ROW_LENGTH:Int
Const GL_UNPACK_SKIP_PIXELS:Int
Const GL_UNPACK_SKIP_ROWS:Int
Const GL_UNPACK_SWAP_BYTES:Int
Const GL_ZOOM_X:Int
Const GL_ZOOM_Y:Int

/* Texture mapping */
Const GL_TEXTURE_ENV:Int
Const GL_TEXTURE_ENV_MODE:Int
Const GL_TEXTURE_1D:Int
Const GL_TEXTURE_2D:Int
Const GL_TEXTURE_WRAP_S:Int
Const GL_TEXTURE_WRAP_T:Int
Const GL_TEXTURE_MAG_FILTER:Int
Const GL_TEXTURE_MIN_FILTER:Int
Const GL_TEXTURE_ENV_COLOR:Int
Const GL_TEXTURE_GEN_S:Int
Const GL_TEXTURE_GEN_T:Int
Const GL_TEXTURE_GEN_MODE:Int
Const GL_TEXTURE_BORDER_COLOR:Int
Const GL_TEXTURE_WIDTH:Int
Const GL_TEXTURE_HEIGHT:Int
Const GL_TEXTURE_BORDER:Int
Const GL_TEXTURE_COMPONENTS:Int
Const GL_TEXTURE_RED_SIZE:Int
Const GL_TEXTURE_GREEN_SIZE:Int
Const GL_TEXTURE_BLUE_SIZE:Int
Const GL_TEXTURE_ALPHA_SIZE:Int
Const GL_TEXTURE_LUMINANCE_SIZE:Int
Const GL_TEXTURE_INTENSITY_SIZE:Int
Const GL_NEAREST_MIPMAP_NEAREST:Int
Const GL_NEAREST_MIPMAP_LINEAR:Int
Const GL_LINEAR_MIPMAP_NEAREST:Int
Const GL_LINEAR_MIPMAP_LINEAR:Int
Const GL_OBJECT_LINEAR:Int
Const GL_OBJECT_PLANE:Int
Const GL_EYE_LINEAR:Int
Const GL_EYE_PLANE:Int
Const GL_SPHERE_MAP:Int
Const GL_DECAL:Int
Const GL_MODULATE:Int
Const GL_NEAREST:Int
Const GL_REPEAT:Int
Const GL_CLAMP:Int
Const GL_S:Int
Const GL_T:Int
Const GL_R:Int
Const GL_Q:Int
Const GL_TEXTURE_GEN_R:Int
Const GL_TEXTURE_GEN_Q:Int

/* Utility */
Const GL_VENDOR:Int
Const GL_RENDERER:Int
Const GL_VERSION:Int
Const GL_EXTENSIONS:Int

/* Errors */
Const GL_NO_ERROR:Int
Const GL_INVALID_VALUE:Int
Const GL_INVALID_ENUM:Int
Const GL_INVALID_OPERATION:Int
Const GL_STACK_OVERFLOW:Int
Const GL_STACK_UNDERFLOW:Int
Const GL_OUT_OF_MEMORY:Int

/* glPush/PopAttrib bits */
Const GL_CURRENT_BIT:Int
Const GL_POINT_BIT:Int
Const GL_LINE_BIT:Int
Const GL_POLYGON_BIT:Int
Const GL_POLYGON_STIPPLE_BIT:Int
Const GL_PIXEL_MODE_BIT:Int
Const GL_LIGHTING_BIT:Int
Const GL_FOG_BIT:Int
Const GL_DEPTH_BUFFER_BIT:Int
Const GL_ACCUM_BUFFER_BIT:Int
Const GL_STENCIL_BUFFER_BIT:Int
Const GL_VIEWPORT_BIT:Int
Const GL_TRANSFORM_BIT:Int
Const GL_ENABLE_BIT:Int
Const GL_COLOR_BUFFER_BIT:Int
Const GL_HINT_BIT:Int
Const GL_EVAL_BIT:Int
Const GL_LIST_BIT:Int
Const GL_TEXTURE_BIT:Int
Const GL_SCISSOR_BIT:Int
Const GL_ALL_ATTRIB_BITS:Int


/* OpenGL 1.1 */
Const GL_PROXY_TEXTURE_1D:Int
Const GL_PROXY_TEXTURE_2D:Int
Const GL_TEXTURE_PRIORITY:Int
Const GL_TEXTURE_RESIDENT:Int
Const GL_TEXTURE_BINDING_1D:Int
Const GL_TEXTURE_BINDING_2D:Int
Const GL_TEXTURE_INTERNAL_FORMAT:Int
Const GL_ALPHA4:Int
Const GL_ALPHA8:Int
Const GL_ALPHA12:Int
Const GL_ALPHA16:Int
Const GL_LUMINANCE4:Int
Const GL_LUMINANCE8:Int
Const GL_LUMINANCE12:Int
Const GL_LUMINANCE16:Int
Const GL_LUMINANCE4_ALPHA4:Int
Const GL_LUMINANCE6_ALPHA2:Int
Const GL_LUMINANCE8_ALPHA8:Int
Const GL_LUMINANCE12_ALPHA4:Int
Const GL_LUMINANCE12_ALPHA12:Int
Const GL_LUMINANCE16_ALPHA16:Int
Const GL_INTENSITY:Int
Const GL_INTENSITY4:Int
Const GL_INTENSITY8:Int
Const GL_INTENSITY12:Int
Const GL_INTENSITY16:Int
Const GL_R3_G3_B2:Int
Const GL_RGB4:Int
Const GL_RGB5:Int
Const GL_RGB8:Int
Const GL_RGB10:Int
Const GL_RGB12:Int
Const GL_RGB16:Int
Const GL_RGBA2:Int
Const GL_RGBA4:Int
Const GL_RGB5_A1:Int
Const GL_RGBA8:Int
Const GL_RGB10_A2:Int
Const GL_RGBA12:Int
Const GL_RGBA16:Int
Const GL_CLIENT_PIXEL_STORE_BIT:Int
Const GL_CLIENT_VERTEX_ARRAY_BIT:Int
Const GL_ALL_CLIENT_ATTRIB_BITS:Int
Const GL_CLIENT_ALL_ATTRIB_BITS:Int

/* OpenGL 1.2 */
Const GL_RESCALE_NORMAL:Int
Const GL_CLAMP_TO_EDGE:Int
Const GL_MAX_ELEMENTS_VERTICES:Int
Const GL_MAX_ELEMENTS_INDICES:Int
Const GL_BGR:Int
Const GL_BGRA:Int
Const GL_UNSIGNED_BYTE_3_3_2:Int
Const GL_UNSIGNED_BYTE_2_3_3_REV:Int
Const GL_UNSIGNED_SHORT_5_6_5:Int
Const GL_UNSIGNED_SHORT_5_6_5_REV:Int
Const GL_UNSIGNED_SHORT_4_4_4_4:Int
Const GL_UNSIGNED_SHORT_4_4_4_4_REV:Int
Const GL_UNSIGNED_SHORT_5_5_5_1:Int
Const GL_UNSIGNED_SHORT_1_5_5_5_REV:Int
Const GL_UNSIGNED_INT_8_8_8_8:Int
Const GL_UNSIGNED_INT_8_8_8_8_REV:Int
Const GL_UNSIGNED_INT_10_10_10_2:Int
Const GL_UNSIGNED_INT_2_10_10_10_REV:Int
Const GL_LIGHT_MODEL_COLOR_CONTROL:Int
Const GL_SINGLE_COLOR:Int
Const GL_SEPARATE_SPECULAR_COLOR:Int
Const GL_TEXTURE_MIN_LOD:Int
Const GL_TEXTURE_MAX_LOD:Int
Const GL_TEXTURE_BASE_LEVEL:Int
Const GL_TEXTURE_MAX_LEVEL:Int
Const GL_SMOOTH_POINT_SIZE_RANGE:Int
Const GL_SMOOTH_POINT_SIZE_GRANULARITY:Int
Const GL_SMOOTH_LINE_WIDTH_RANGE:Int
Const GL_SMOOTH_LINE_WIDTH_GRANULARITY:Int
Const GL_ALIASED_POINT_SIZE_RANGE:Int
Const GL_ALIASED_LINE_WIDTH_RANGE:Int
Const GL_PACK_SKIP_IMAGES:Int
Const GL_PACK_IMAGE_HEIGHT:Int
Const GL_UNPACK_SKIP_IMAGES:Int
Const GL_UNPACK_IMAGE_HEIGHT:Int
Const GL_TEXTURE_3D:Int
Const GL_PROXY_TEXTURE_3D:Int
Const GL_TEXTURE_DEPTH:Int
Const GL_TEXTURE_WRAP_R:Int
Const GL_MAX_3D_TEXTURE_SIZE:Int
Const GL_TEXTURE_BINDING_3D:Int

/* OpenGL 1.2 imaging subset */
/* GL_EXT_color_table */
Const GL_COLOR_TABLE:Int
Const GL_POST_CONVOLUTION_COLOR_TABLE:Int
Const GL_POST_COLOR_MATRIX_COLOR_TABLE:Int
Const GL_PROXY_COLOR_TABLE:Int
Const GL_PROXY_POST_CONVOLUTION_COLOR_TABLE:Int
Const GL_PROXY_POST_COLOR_MATRIX_COLOR_TABLE:Int
Const GL_COLOR_TABLE_SCALE:Int
Const GL_COLOR_TABLE_BIAS:Int
Const GL_COLOR_TABLE_FORMAT:Int
Const GL_COLOR_TABLE_WIDTH:Int
Const GL_COLOR_TABLE_RED_SIZE:Int
Const GL_COLOR_TABLE_GREEN_SIZE:Int
Const GL_COLOR_TABLE_BLUE_SIZE:Int
Const GL_COLOR_TABLE_ALPHA_SIZE:Int
Const GL_COLOR_TABLE_LUMINANCE_SIZE:Int
Const GL_COLOR_TABLE_INTENSITY_SIZE:Int
/* GL_EXT_convolution and GL_HP_convolution_border_modes */
Const GL_CONVOLUTION_1D:Int
Const GL_CONVOLUTION_2D:Int
Const GL_SEPARABLE_2D:Int
Const GL_CONVOLUTION_BORDER_MODE:Int
Const GL_CONVOLUTION_FILTER_SCALE:Int
Const GL_CONVOLUTION_FILTER_BIAS:Int
Const GL_REDUCE:Int
Const GL_CONVOLUTION_FORMAT:Int
Const GL_CONVOLUTION_WIDTH:Int
Const GL_CONVOLUTION_HEIGHT:Int
Const GL_MAX_CONVOLUTION_WIDTH:Int
Const GL_MAX_CONVOLUTION_HEIGHT:Int
Const GL_POST_CONVOLUTION_RED_SCALE:Int
Const GL_POST_CONVOLUTION_GREEN_SCALE:Int
Const GL_POST_CONVOLUTION_BLUE_SCALE:Int
Const GL_POST_CONVOLUTION_ALPHA_SCALE:Int
Const GL_POST_CONVOLUTION_RED_BIAS:Int
Const GL_POST_CONVOLUTION_GREEN_BIAS:Int
Const GL_POST_CONVOLUTION_BLUE_BIAS:Int
Const GL_POST_CONVOLUTION_ALPHA_BIAS:Int
Const GL_CONSTANT_BORDER:Int
Const GL_REPLICATE_BORDER:Int
Const GL_CONVOLUTION_BORDER_COLOR:Int
/* GL_SGI_color_matrix */
Const GL_COLOR_MATRIX:Int
Const GL_COLOR_MATRIX_STACK_DEPTH:Int
Const GL_MAX_COLOR_MATRIX_STACK_DEPTH:Int
Const GL_POST_COLOR_MATRIX_RED_SCALE:Int
Const GL_POST_COLOR_MATRIX_GREEN_SCALE:Int
Const GL_POST_COLOR_MATRIX_BLUE_SCALE:Int
Const GL_POST_COLOR_MATRIX_ALPHA_SCALE:Int
Const GL_POST_COLOR_MATRIX_RED_BIAS:Int
Const GL_POST_COLOR_MATRIX_GREEN_BIAS:Int
Const GL_POST_COLOR_MATRIX_BLUE_BIAS:Int
Const GL_POST_COLOR_MATRIX_ALPHA_BIAS:Int
/* GL_EXT_histogram */
Const GL_HISTOGRAM:Int
Const GL_PROXY_HISTOGRAM:Int
Const GL_HISTOGRAM_WIDTH:Int
Const GL_HISTOGRAM_FORMAT:Int
Const GL_HISTOGRAM_RED_SIZE:Int
Const GL_HISTOGRAM_GREEN_SIZE:Int
Const GL_HISTOGRAM_BLUE_SIZE:Int
Const GL_HISTOGRAM_ALPHA_SIZE:Int
Const GL_HISTOGRAM_LUMINANCE_SIZE:Int
Const GL_HISTOGRAM_SINK:Int
Const GL_MINMAX:Int
Const GL_MINMAX_FORMAT:Int
Const GL_MINMAX_SINK:Int
Const GL_TABLE_TOO_LARGE:Int
/* GL_EXT_blend_color, GL_EXT_blend_minmax */
Const GL_BLEND_EQUATION:Int
Const GL_MIN:Int
Const GL_MAX:Int
Const GL_FUNC_ADD:Int
Const GL_FUNC_SUBTRACT:Int
Const GL_FUNC_REVERSE_SUBTRACT:Int
Const GL_BLEND_COLOR:Int


/* OpenGL 1.3 */
/* multitexture */
Const GL_TEXTURE0:Int
Const GL_TEXTURE1:Int
Const GL_TEXTURE2:Int
Const GL_TEXTURE3:Int
Const GL_TEXTURE4:Int
Const GL_TEXTURE5:Int
Const GL_TEXTURE6:Int
Const GL_TEXTURE7:Int
Const GL_TEXTURE8:Int
Const GL_TEXTURE9:Int
Const GL_TEXTURE10:Int
Const GL_TEXTURE11:Int
Const GL_TEXTURE12:Int
Const GL_TEXTURE13:Int
Const GL_TEXTURE14:Int
Const GL_TEXTURE15:Int
Const GL_TEXTURE16:Int
Const GL_TEXTURE17:Int
Const GL_TEXTURE18:Int
Const GL_TEXTURE19:Int
Const GL_TEXTURE20:Int
Const GL_TEXTURE21:Int
Const GL_TEXTURE22:Int
Const GL_TEXTURE23:Int
Const GL_TEXTURE24:Int
Const GL_TEXTURE25:Int
Const GL_TEXTURE26:Int
Const GL_TEXTURE27:Int
Const GL_TEXTURE28:Int
Const GL_TEXTURE29:Int
Const GL_TEXTURE30:Int
Const GL_TEXTURE31:Int
Const GL_ACTIVE_TEXTURE:Int
Const GL_CLIENT_ACTIVE_TEXTURE:Int
Const GL_MAX_TEXTURE_UNITS:Int
/* texture_cube_map */
Const GL_NORMAL_MAP:Int
Const GL_REFLECTION_MAP:Int
Const GL_TEXTURE_CUBE_MAP:Int
Const GL_TEXTURE_BINDING_CUBE_MAP:Int
Const GL_TEXTURE_CUBE_MAP_POSITIVE_X:Int
Const GL_TEXTURE_CUBE_MAP_NEGATIVE_X:Int
Const GL_TEXTURE_CUBE_MAP_POSITIVE_Y:Int
Const GL_TEXTURE_CUBE_MAP_NEGATIVE_Y:Int
Const GL_TEXTURE_CUBE_MAP_POSITIVE_Z:Int
Const GL_TEXTURE_CUBE_MAP_NEGATIVE_Z:Int
Const GL_PROXY_TEXTURE_CUBE_MAP:Int
Const GL_MAX_CUBE_MAP_TEXTURE_SIZE:Int
/* texture_compression */
Const GL_COMPRESSED_ALPHA:Int
Const GL_COMPRESSED_LUMINANCE:Int
Const GL_COMPRESSED_LUMINANCE_ALPHA:Int
Const GL_COMPRESSED_INTENSITY:Int
Const GL_COMPRESSED_RGB:Int
Const GL_COMPRESSED_RGBA:Int
Const GL_TEXTURE_COMPRESSION_HINT:Int
Const GL_TEXTURE_COMPRESSED_IMAGE_SIZE:Int
Const GL_TEXTURE_COMPRESSED:Int
Const GL_NUM_COMPRESSED_TEXTURE_FORMATS:Int
Const GL_COMPRESSED_TEXTURE_FORMATS:Int
/* multisample */
Const GL_MULTISAMPLE:Int
Const GL_SAMPLE_ALPHA_TO_COVERAGE:Int
Const GL_SAMPLE_ALPHA_TO_ONE:Int
Const GL_SAMPLE_COVERAGE:Int
Const GL_SAMPLE_BUFFERS:Int
Const GL_SAMPLES:Int
Const GL_SAMPLE_COVERAGE_VALUE:Int
Const GL_SAMPLE_COVERAGE_INVERT:Int
Const GL_MULTISAMPLE_BIT:Int
/* transpose_matrix */
Const GL_TRANSPOSE_MODELVIEW_MATRIX:Int
Const GL_TRANSPOSE_PROJECTION_MATRIX:Int
Const GL_TRANSPOSE_TEXTURE_MATRIX:Int
Const GL_TRANSPOSE_COLOR_MATRIX:Int
/* texture_env_combine */
Const GL_COMBINE:Int
Const GL_COMBINE_RGB:Int
Const GL_COMBINE_ALPHA:Int
Const GL_SOURCE0_RGB:Int
Const GL_SOURCE1_RGB:Int
Const GL_SOURCE2_RGB:Int
Const GL_SOURCE0_ALPHA:Int
Const GL_SOURCE1_ALPHA:Int
Const GL_SOURCE2_ALPHA:Int
Const GL_OPERAND0_RGB:Int
Const GL_OPERAND1_RGB:Int
Const GL_OPERAND2_RGB:Int
Const GL_OPERAND0_ALPHA:Int
Const GL_OPERAND1_ALPHA:Int
Const GL_OPERAND2_ALPHA:Int
Const GL_RGB_SCALE:Int
Const GL_ADD_SIGNED:Int
Const GL_INTERPOLATE:Int
Const GL_SUBTRACT:Int
Const GL_CONSTANT:Int
Const GL_PRIMARY_COLOR:Int
Const GL_PREVIOUS:Int
/* texture_env_dot3 */
Const GL_DOT3_RGB:Int
Const GL_DOT3_RGBA:Int
/* texture_border_clamp */
Const GL_CLAMP_TO_BORDER:Int


/************************************************************************
 *
 * Function prototypes
 *
 ************************************************************************/

/* Miscellaneous */
Function glClearIndex(c:Float)
Function glClearColor(red:Float, green:Float, blue:Float, alpha:Float)
Function glClear(mask:UInt)
Function glIndexMask(mask:UInt)
Function glColorMask(red:UByte, green:UByte, blue:UByte, alpha:UByte)
Function glAlphaFunc(func:UInt, ref:Float)
Function glBlendFunc(sfactor:UInt, dfactor:UInt)
Function glLogicOp(opcode:UInt)
Function glCullFace(mode:UInt)
Function glFrontFace(mode:UInt)
Function glPointSize(size:Float)
Function glLineWidth(width:Float)
Function glLineStipple(factor:Int, pattern:UShort)
Function glPolygonMode(face:UInt, mode:UInt)
Function glPolygonOffset(factor:Float, units:Float)
Function glPolygonStipple(mask:UByte Ptr)
Function glGetPolygonStipple(mask:UByte Ptr)
Function glEdgeFlag(flag:UByte)
Function glEdgeFlagv(flag:UByte Ptr)
Function glScissor(x:Int, y:Int, width:Int, height:Int)
Function glClipPlane(plane:UInt, equation:Double Ptr)
Function glGetClipPlane(plane:UInt, equation:Double Ptr)
Function glDrawBuffer(mode:UInt)
Function glReadBuffer(mode:UInt)
Function glEnable(cap:UInt)
Function glDisable(cap:UInt)
Function glIsEnabled:UByte(cap:UInt)
Function glEnableClientState(cap:UInt)  /* 1.1 */
Function glDisableClientState(cap:UInt)  /* 1.1 */
Function glGetBooleanv(pname:UInt, params:UByte Ptr)
Function glGetDoublev(pname:UInt, params:Double Ptr)
Function glGetFloatv(pname:UInt, params:Float Ptr)
Function glGetIntegerv(pname:UInt, params:Int Ptr)
Function glPushAttrib(mask:UInt)
Function glPopAttrib()
Function glPushClientAttrib(mask:UInt)  /* 1.1 */
Function glPopClientAttrib()  /* 1.1 */
Function glRenderMode:Int(mode:UInt)
Function glGetError:Int()
Function glGetString:UByte Ptr(name:UInt)
Function glFinish()
Function glFlush()
Function glHint(target:UInt, mode:UInt)

/* Depth Buffer */
Function glClearDepth(depth:Double)
Function glDepthFunc(func:UInt)
Function glDepthMask(flag:UByte)
Function glDepthRange(near_val:Double, far_val:Double)

/* Accumulation Buffer */
Function glClearAccum(red:Float, green:Float, blue:Float, alpha:Float)
Function glAccum(op:UInt, value:Float)

/* Transformation */
Function glMatrixMode(mode:UInt)
Function glOrtho(left:Double, right:Double, bottom:Double, top:Double, near_val:Double, far_val:Double)
Function glFrustum(left:Double, right:Double, bottom:Double, top:Double, near_val:Double, far_val:Double)
Function glViewport(x:Int, y:Int, width:Int, height:Int)
Function glPushMatrix()
Function glPopMatrix()
Function glLoadIdentity()
Function glLoadMatrixd(m:Double Ptr)
Function glLoadMatrixf(m:Float Ptr)
Function glMultMatrixd(m:Double Ptr)
Function glMultMatrixf(m:Float Ptr)
Function glRotated(angle:Double, x:Double, y:Double, z:Double)
Function glRotatef(angle:Float, x:Float, y:Float, z:Float)
Function glScaled(x:Double, y:Double, z:Double)
Function glScalef(x:Float, y:Float, z:Float)
Function glTranslated(x:Double, y:Double, z:Double)
Function glTranslatef(x:Float, y:Float, z:Float)

/* Display Lists */
Function glIsList:UByte(list:UInt)
Function glDeleteLists(list:UInt, range:Int)
Function glGenLists:UInt(range:Int)
Function glNewList(list:UInt, mode:UInt)
Function glEndList()
Function glCallList(list:UInt)
Function glCallLists(n:Int, type:UInt, lists:Void Ptr)
Function glListBase(base:UInt)

/* Drawing Functions */
Function glBegin(mode:UInt)
Function glEnd()
Function glVertex2d(x:Double, y:Double)
Function glVertex2f(x:Float, y:Float)
Function glVertex2i(x:Int, y:Int)
Function glVertex2s(x:Short, y:Short)
Function glVertex3d(x:Double, y:Double, z:Double)
Function glVertex3f(x:Float, y:Float, z:Float)
Function glVertex3i(x:Int, y:Int, z:Int)
Function glVertex3s(x:Short, y:Short, z:Short)
Function glVertex4d(x:Double, y:Double, z:Double, w:Double)
Function glVertex4f(x:Float, y:Float, z:Float, w:Float)
Function glVertex4i(x:Int, y:Int, z:Int, w:Int)
Function glVertex4s(x:Short, y:Short, z:Short, w:Short)
Function glVertex2dv(v:Double Ptr)
Function glVertex2fv(v:Float Ptr)
Function glVertex2iv(v:Int Ptr)
Function glVertex2sv(v:Short Ptr)
Function glVertex3dv(v:Double Ptr)
Function glVertex3fv(v:Float Ptr)
Function glVertex3iv(v:Int Ptr)
Function glVertex3sv(v:Short Ptr)
Function glVertex4dv(v:Double Ptr)
Function glVertex4fv(v:Float Ptr)
Function glVertex4iv(v:Int Ptr)
Function glVertex4sv(v:Short Ptr)
Function glNormal3b(nx:Byte, ny:Byte, nz:Byte)
Function glNormal3d(nx:Double, ny:Double, nz:Double)
Function glNormal3f(nx:Float, ny:Float, nz:Float)
Function glNormal3i(nx:Int, ny:Int, nz:Int)
Function glNormal3s(nx:Short, ny:Short, nz:Short)
Function glNormal3bv(v:Byte Ptr)
Function glNormal3dv(v:Double Ptr)
Function glNormal3fv(v:Float Ptr)
Function glNormal3iv(v:Int Ptr)
Function glNormal3sv(v:Short Ptr)
Function glIndexd(c:Double)
Function glIndexf(c:Float)
Function glIndexi(c:Int)
Function glIndexs(c:Short)
Function glIndexub(c:UByte)  /* 1.1 */
Function glIndexdv(c:Double Ptr)
Function glIndexfv(c:Float Ptr)
Function glIndexiv(c:Int Ptr)
Function glIndexsv(c:Short Ptr)
Function glIndexubv(c:UByte Ptr)  /* 1.1 */
Function glColor3b(red:Byte, green:Byte, blue:Byte)
Function glColor3d(red:Double, green:Double, blue:Double)
Function glColor3f(red:Float, green:Float, blue:Float)
Function glColor3i(red:Int, green:Int, blue:Int)
Function glColor3s(red:Short, green:Short, blue:Short)
Function glColor3ub(red:UByte, green:UByte, blue:UByte)
Function glColor3ui(red:UInt, green:UInt, blue:UInt)
Function glColor3us(red:UShort, green:UShort, blue:UShort)
Function glColor4b(red:Byte, green:Byte, blue:Byte, alpha:Byte)
Function glColor4d(red:Double, green:Double, blue:Double, alpha:Double)
Function glColor4f(red:Float, green:Float, blue:Float, alpha:Float)
Function glColor4i(red:Int, green:Int, blue:Int, alpha:Int)
Function glColor4s(red:Short, green:Short, blue:Short, alpha:Short)
Function glColor4ub(red:UByte, green:UByte, blue:UByte, alpha:UByte)
Function glColor4ui(red:UInt, green:UInt, blue:UInt, alpha:UInt)
Function glColor4us(red:UShort, green:UShort, blue:UShort, alpha:UShort)
Function glColor3bv(v:Byte Ptr)
Function glColor3dv(v:Double Ptr)
Function glColor3fv(v:Float Ptr)
Function glColor3iv(v:Int Ptr)
Function glColor3sv(v:Short Ptr)
Function glColor3ubv(v:UByte Ptr)
Function glColor3uiv(v:UInt Ptr)
Function glColor3usv(v:UShort Ptr)
Function glColor4bv(v:Byte Ptr)
Function glColor4dv(v:Double Ptr)
Function glColor4fv(v:Float Ptr)
Function glColor4iv(v:Int Ptr)
Function glColor4sv(v:Short Ptr)
Function glColor4ubv(v:UByte Ptr)
Function glColor4uiv(v:UInt Ptr)
Function glColor4usv(v:UShort Ptr)
Function glTexCoord1d(s:Double)
Function glTexCoord1f(s:Float)
Function glTexCoord1i(s:Int)
Function glTexCoord1s(s:Short)
Function glTexCoord2d(s:Double, t:Double)
Function glTexCoord2f(s:Float, t:Float)
Function glTexCoord2i(s:Int, t:Int)
Function glTexCoord2s(s:Short, t:Short)
Function glTexCoord3d(s:Double, t:Double, r:Double)
Function glTexCoord3f(s:Float, t:Float, r:Float)
Function glTexCoord3i(s:Int, t:Int, r:Int)
Function glTexCoord3s(s:Short, t:Short, r:Short)
Function glTexCoord4d(s:Double, t:Double, r:Double, q:Double)
Function glTexCoord4f(s:Float, t:Float, r:Float, q:Float)
Function glTexCoord4i(s:Int, t:Int, r:Int, q:Int)
Function glTexCoord4s(s:Short, t:Short, r:Short, q:Short)
Function glTexCoord1dv(v:Double Ptr)
Function glTexCoord1fv(v:Float Ptr)
Function glTexCoord1iv(v:Int Ptr)
Function glTexCoord1sv(v:Short Ptr)
Function glTexCoord2dv(v:Double Ptr)
Function glTexCoord2fv(v:Float Ptr)
Function glTexCoord2iv(v:Int Ptr)
Function glTexCoord2sv(v:Short Ptr)
Function glTexCoord3dv(v:Double Ptr)
Function glTexCoord3fv(v:Float Ptr)
Function glTexCoord3iv(v:Int Ptr)
Function glTexCoord3sv(v:Short Ptr)
Function glTexCoord4dv(v:Double Ptr)
Function glTexCoord4fv(v:Float Ptr)
Function glTexCoord4iv(v:Int Ptr)
Function glTexCoord4sv(v:Short Ptr)
Function glRasterPos2d(x:Double, y:Double)
Function glRasterPos2f(x:Float, y:Float)
Function glRasterPos2i(x:Int, y:Int)
Function glRasterPos2s(x:Short, y:Short)
Function glRasterPos3d(x:Double, y:Double, z:Double)
Function glRasterPos3f(x:Float, y:Float, z:Float)
Function glRasterPos3i(x:Int, y:Int, z:Int)
Function glRasterPos3s(x:Short, y:Short, z:Short)
Function glRasterPos4d(x:Double, y:Double, z:Double, w:Double)
Function glRasterPos4f(x:Float, y:Float, z:Float, w:Float)
Function glRasterPos4i(x:Int, y:Int, z:Int, w:Int)
Function glRasterPos4s(x:Short, y:Short, z:Short, w:Short)
Function glRasterPos2dv(v:Double Ptr)
Function glRasterPos2fv(v:Float Ptr)
Function glRasterPos2iv(v:Int Ptr)
Function glRasterPos2sv(v:Short Ptr)
Function glRasterPos3dv(v:Double Ptr)
Function glRasterPos3fv(v:Float Ptr)
Function glRasterPos3iv(v:Int Ptr)
Function glRasterPos3sv(v:Short Ptr)
Function glRasterPos4dv(v:Double Ptr)
Function glRasterPos4fv(v:Float Ptr)
Function glRasterPos4iv(v:Int Ptr)
Function glRasterPos4sv(v:Short Ptr)
Function glRectd(x1:Double, y1:Double, x2:Double, y2:Double)
Function glRectf(x1:Float, y1:Float, x2:Float, y2:Float)
Function glRecti(x1:Int, y1:Int, x2:Int, y2:Int)
Function glRects(x1:Short, y1:Short, x2:Short, y2:Short)
Function glRectdv(v1:Double Ptr, v2:Double Ptr)
Function glRectfv(v1:Float Ptr, v2:Float Ptr)
Function glRectiv(v1:Int Ptr, v2:Int Ptr)
Function glRectsv(v1:Short Ptr, v2:Short Ptr)

/* Lighting */
Function glShadeModel(mode:UInt)
Function glLightf(light:UInt, pname:UInt, param:Float)
Function glLighti(light:UInt, pname:UInt, param:Int)
Function glLightfv(light:UInt, pname:UInt, params:Float Ptr)
Function glLightiv(light:UInt, pname:UInt, params:Int Ptr)
Function glGetLightfv(light:UInt, pname:UInt, params:Float Ptr)
Function glGetLightiv(light:UInt, pname:UInt, params:Int Ptr)
Function glLightModelf(pname:UInt, param:Float)
Function glLightModeli(pname:UInt, param:Int)
Function glLightModelfv(pname:UInt, params:Float Ptr)
Function glLightModeliv(pname:UInt, params:Int Ptr)
Function glMaterialf(face:UInt, pname:UInt, param:Float)
Function glMateriali(face:UInt, pname:UInt, param:Int)
Function glMaterialfv(face:UInt, pname:UInt, params:Float Ptr)
Function glMaterialiv(face:UInt, pname:UInt, params:Int Ptr)
Function glGetMaterialfv(face:UInt, pname:UInt, params:Float Ptr)
Function glGetMaterialiv(face:UInt, pname:UInt, params:Int Ptr)
Function glColorMaterial(face:UInt, mode:UInt)

/* Raster functions */
Function glPixelZoom(xfactor:Float, yfactor:Float)
Function glPixelStoref(pname:UInt, param:Float)
Function glPixelStorei(pname:UInt, param:Int)
Function glPixelTransferf(pname:UInt, param:Float)
Function glPixelTransferi(pname:UInt, param:Int)
Function glPixelMapfv(map:UInt, mapsize:Int, values:Float Ptr)
Function glPixelMapuiv(map:UInt, mapsize:Int, values:UInt Ptr)
Function glPixelMapusv(map:UInt, mapsize:Int, values:UShort Ptr)
Function glGetPixelMapfv(map:UInt, values:Float Ptr)
Function glGetPixelMapuiv(map:UInt, values:UInt Ptr)
Function glGetPixelMapusv(map:UInt, values:UShort Ptr)
Function glBitmap(width:Int, height:Int, xorig:Float, yorig:Float, xmove:Float, ymove:Float, bitmap:UByte Ptr)
Function glReadPixels(x:Int, y:Int, width:Int, height:Int, format:UInt, type:UInt, pixels:Void Ptr)
Function glDrawPixels(width:Int, height:Int, format:UInt, type:UInt, pixels:Void Ptr)
Function glCopyPixels(x:Int, y:Int, width:Int, height:Int, type:UInt)

/* Stenciling */
Function glStencilFunc(func:UInt, ref:Int, mask:UInt)
Function glStencilMask(mask:UInt)
Function glStencilOp(fail:UInt, zfail:UInt, zpass:UInt)
Function glClearStencil(s:Int)

/* Texture mapping */
Function glTexGend(coord:UInt, pname:UInt, param:Double)
Function glTexGenf(coord:UInt, pname:UInt, param:Float)
Function glTexGeni(coord:UInt, pname:UInt, param:Int)
Function glTexGendv(coord:UInt, pname:UInt, params:Double Ptr)
Function glTexGenfv(coord:UInt, pname:UInt, params:Float Ptr)
Function glTexGeniv(coord:UInt, pname:UInt, params:Int Ptr)
Function glGetTexGendv(coord:UInt, pname:UInt, params:Double Ptr)
Function glGetTexGenfv(coord:UInt, pname:UInt, params:Float Ptr)
Function glGetTexGeniv(coord:UInt, pname:UInt, params:Int Ptr)
Function glTexEnvf(target:UInt, pname:UInt, param:Float)
Function glTexEnvi(target:UInt, pname:UInt, param:Int)
Function glTexEnvfv(target:UInt, pname:UInt, params:Float Ptr)
Function glTexEnviv(target:UInt, pname:UInt, params:Int Ptr)
Function glGetTexEnvfv(target:UInt, pname:UInt, params:Float Ptr)
Function glGetTexEnviv(target:UInt, pname:UInt, params:Int Ptr)
Function glTexParameterf(target:UInt, pname:UInt, param:Float)
Function glTexParameteri(target:UInt, pname:UInt, param:Int)
Function glTexParameterfv(target:UInt, pname:UInt, params:Float Ptr)
Function glTexParameteriv(target:UInt, pname:UInt, params:Int Ptr)
Function glGetTexParameterfv(target:UInt, pname:UInt, params:Float Ptr)
Function glGetTexParameteriv(target:UInt, pname:UInt, params:Int Ptr)
Function glGetTexLevelParameterfv(target:UInt, level:Int, pname:UInt, params:Float Ptr)
Function glGetTexLevelParameteriv(target:UInt, level:Int, pname:UInt, params:Int Ptr)
Function glTexImage1D(target:UInt, level:Int, internalFormat:Int, width:Int, border:Int, format:UInt, type:UInt, pixels:Void Ptr)
Function glTexImage2D(target:UInt, level:Int, internalFormat:Int, width:Int, height:Int, border:Int, format:UInt, type:UInt, pixels:Void Ptr)
Function glGetTexImage(target:UInt, level:Int, format:UInt, type:UInt, pixels:Void Ptr)

/* Evaluators */
Function glMap1d(target:UInt, u1:Double, u2:Double, stride:Int, order:Int, points:Double Ptr)
Function glMap1f(target:UInt, u1:Float, u2:Float, stride:Int, order:Int, points:Float Ptr)
Function glMap2d(target:UInt, u1:Double, u2:Double, ustride:Int, uorder:Int, v1:Double, v2:Double, vstride:Int, vorder:Int, points:Double Ptr)
Function glMap2f(target:UInt, u1:Float, u2:Float, ustride:Int, uorder:Int, v1:Float, v2:Float, vstride:Int, vorder:Int, points:Float Ptr)
Function glGetMapdv(target:UInt, query:UInt, v:Double Ptr)
Function glGetMapfv(target:UInt, query:UInt, v:Float Ptr)
Function glGetMapiv(target:UInt, query:UInt, v:Int Ptr)
Function glEvalCoord1d(u:Double)
Function glEvalCoord1f(u:Float)
Function glEvalCoord1dv(u:Double Ptr)
Function glEvalCoord1fv(u:Float Ptr)
Function glEvalCoord2d(u:Double, v:Double)
Function glEvalCoord2f(u:Float, v:Float)
Function glEvalCoord2dv(u:Double Ptr)
Function glEvalCoord2fv(u:Float Ptr)
Function glMapGrid1d(un:Int, u1:Double, u2:Double)
Function glMapGrid1f(un:Int, u1:Float, u2:Float)
Function glMapGrid2d(un:Int, u1:Double, u2:Double, vn:Int, v1:Double, v2:Double)
Function glMapGrid2f(un:Int, u1:Float, u2:Float, vn:Int, v1:Float, v2:Float)
Function glEvalPoint1(i:Int)
Function glEvalPoint2(i:Int, j:Int)
Function glEvalMesh1(mode:UInt, i1:Int, i2:Int)
Function glEvalMesh2(mode:UInt, i1:Int, i2:Int, j1:Int, j2:Int)

/* Fog */
Function glFogf(pname:UInt, param:Float)
Function glFogi(pname:UInt, param:Int)
Function glFogfv(pname:UInt, params:Float Ptr)
Function glFogiv(pname:UInt, params:Int Ptr)

/* Selection and Feedback */
Function glFeedbackBuffer(size:Int, type:UInt, buffer:Float Ptr)
Function glPassThrough(token:Float)
Function glSelectBuffer(size:Int, buffer:UInt Ptr)
Function glInitNames()
Function glLoadName(name:UInt)
Function glPushName(name:UInt)
Function glPopName()


/* 1.1 functions */
/* texture objects */
Function glGenTextures(n:Int, textures:UInt Ptr)
Function glDeleteTextures(n:Int, textures:UInt Ptr)
Function glBindTexture(target:UInt, texture:UInt)
Function glPrioritizeTextures(n:Int, textures:UInt Ptr, priorities:Float Ptr)
Function glAreTexturesResident:UByte(n:Int, textures:UInt Ptr, residences:UByte Ptr)
Function glIsTexture:UByte(texture:UInt)
/* texture mapping */
Function glTexSubImage1D(target:UInt, level:Int, xoffset:Int, width:Int, format:UInt, type:UInt, pixels:Void Ptr)
Function glTexSubImage2D(target:UInt, level:Int, xoffset:Int, yoffset:Int, width:Int, height:Int, format:UInt, type:UInt, pixels:Void Ptr)
Function glCopyTexImage1D(target:UInt, level:Int, internalformat:UInt, x:Int, y:Int, width:Int, border:Int)
Function glCopyTexImage2D(target:UInt, level:Int, internalformat:UInt, x:Int, y:Int, width:Int, height:Int, border:Int)
Function glCopyTexSubImage1D(target:UInt, level:Int, xoffset:Int, x:Int, y:Int, width:Int)
Function glCopyTexSubImage2D(target:UInt, level:Int, xoffset:Int, yoffset:Int, x:Int, y:Int, width:Int, height:Int)
/* vertex arrays */
Function glVertexPointer(size:Int, type:UInt, stride:Int, pointer:Void Ptr)
Function glNormalPointer(type:UInt, stride:Int, pointer:Void Ptr)
Function glColorPointer(size:Int, type:UInt, stride:Int, pointer:Void Ptr)
Function glIndexPointer(type:UInt, stride:Int, pointer:Void Ptr)
Function glTexCoordPointer(size:Int, type:UInt, stride:Int, pointer:Void Ptr)
Function glEdgeFlagPointer(stride:Int, pointer:Void Ptr)
Function glGetPointerv(pname:UInt, params:Void Ptr Ptr)
Function glArrayElement(i:Int)
Function glDrawArrays(mode:UInt, first:Int, count:Int)
Function glDrawElements(mode:UInt, count:Int, type:UInt, indices:Void Ptr)
Function InterleavedArrays(format:UInt, stride:Int, pointer:Void Ptr)

EndExtern
