#include "FileStream.h"
#include "ClassTFileStream.h"
String* LoadText(String* Path){
	TStream* Instream = (ReadFile(Path));
	if (Instream){
		int32_t Size = (Instream)->Size();
		char* Dest = ((char*)(MemAlloc(((uint32_t)((Size + 1))))));
		(Instream)->ReadBytes(((void*)(Dest)), Size);
		(Dest[Size]) = ((char)(0));
		String* Result = String::FromCString(Dest);
		MemFree(((void*)(Dest)));
		(Instream)->Close();
		return Result;
	};
	return new String("");
};
void SaveText(String* Path, String* Text){
	TStream* Outstream = (WriteFile(Path));
	if (Outstream){
		(Outstream)->WriteBytes(((void*)((Text)->ToCString())), (Text)->Length);
		(Outstream)->Close();
	};
};
TFileStream* ReadFile(String* Path){
	return ((new TFileStream))->Create(_CFileOpen(Path, new String("r+b")));
};
TFileStream* WriteFile(String* Path){
	return ((new TFileStream))->Create(_CFileOpen(Path, new String("w+b")));
};
int32_t TFileStream::ReadBytes(void* Dest, int32_t Count){
	return _CFileReadBytes(CFile, Dest, Count);
};
int32_t TFileStream::WriteBytes(void* Src, int32_t Count){
	return _CFileWriteBytes(CFile, Src, Count);
};
bool TFileStream::Eof(){
	return _CFileEOF(CFile);
};
void TFileStream::Flush(){
	_CFileFlush(CFile);
};
int32_t TFileStream::Pos(){
	return _CFilePos(CFile);
};
void TFileStream::Seek(int32_t Position){
	_CFileSeek(CFile, Position);
};
int32_t TFileStream::Size(){
	return _CFileSize(CFile);
};
void TFileStream::Close(){
	if (CFile){
		_CFileClose(CFile);
		CFile = 0;
	};
};
TFileStream* TFileStream::Create(void* CFile){
	if (!(CFile)){
		return 0;
	};
	(this)->CFile = CFile;
	return this;
};
TFileStream::TFileStream(){
	CFile = 0;
};
void FileStreamMain(){
}