Class TStream
	Method Eof:Bool()
		Return Pos() = Size()
	End Method

	Method Pos:Int() Abstract

	Method Size:Int() Abstract
	Method Seek(Position:Int) Abstract
	Method Flush() Abstract
	Method Close() Abstract

	Method ReadBytes:Int(Dest:Void Ptr, Count:Int) Abstract
    Method WriteBytes:Int(Src:Void Ptr, Count:Int) Abstract

	Method ReadByte:Byte()
		Local Result:Byte
		ReadBytes(VarPtr Result, 1)
		Return Result
	End Method
    
    Method ReadShort:Short()
		Local Result:Short
		ReadBytes(VarPtr Result, 2)
		Return Result
	End Method
    
    Method ReadInt:Int()
		Local Result:Int
		ReadBytes(VarPtr Result, 4)
		Return Result
	End Method
    
    Method ReadLong:Long()
		Local Result:Long
		ReadBytes(VarPtr Result, 8)
		Return Result
	End Method
	
	Method ReadFloat:Float()
		Local Result:Float
		ReadBytes(VarPtr Result, 4)
		Return Result
	End Method

	Method ReadDouble:Double()
		Local Result:Double
		ReadBytes(VarPtr Result, 8)
		Return Result
	End Method

	Method WriteByte(Source:Byte)
		WriteBytes(VarPtr Source, 1)
	End Method

	Method WriteShort(Source:Short)
		WriteBytes(VarPtr Source, 2)
	End Method
	
	Method WriteInt(Source:Int)
		WriteBytes(VarPtr Source, 4)
	End Method
	
	Method WriteLong(Source:Long)
		WriteBytes(VarPtr Source, 8)
	End Method

	Method WriteFloat(Source:Float)
		WriteBytes(VarPtr Source, 4)
	End Method

	Method WriteDouble(Source:Double)
		WriteBytes(VarPtr Source, 8)
	End Method

	Method ReadString:String(Length:Int)
        If Not Length Then Return ""
        
        Local Buffer:Byte[] = New Byte[Length]
        ReadBytes(VarPtr Buffer[0], Length)
        
		Return String.FromBytes(Buffer, Length)
	End Method
	
	Method WriteString(Source:String)
		WriteBytes(Source.Data, Source.Length)
	End Method
    
    Method Finalize()
		Close()
	End Method
End Class