#ifndef __BISMUTH_MATH__
#define __BISMUTH_MATH__

#define _USE_MATH_DEFINES
#include <math.h>
#include <cmath>

/*
ToDo:
- IsNan
- IsInf
*/

float Sqr(float N);

float Sin(float N);
float Cos(float N);
float Tan(float N);

float SinH(float N);
float CosH(float N);
float TanH(float N);

float ASin(float N);
float ACos(float N);
float ATan(float N);
float ATan2(float Y, float X);

float Exp(float N);
float Log(float N);
float Log10(float N);

int Ceil(float N);
int Floor(float N);

double PowerOf(double Base, double Exponent);

bool IsNaN(float N);
bool IsInf(float N);
//int Abs(int N);

#endif //__BISMUTH_MATH__