#include "Random.h"
bool SFMT_Initialized = 0;
int32_t SeedRand(int32_t seed){
	SFMT_Initialized = 1;
	init_gen_rand(seed);
	return 0;
};
int32_t RandInt(int32_t min_value, int32_t max_value){
	if ((SFMT_Initialized == 0)){
		SeedRand(0);
	};
	int32_t range = (max_value - min_value);
	if ((range > 0)){
		return (((int32_t)((genrand_res53() * ((1 + range))))) + min_value);
	} else {
		return (((int32_t)((genrand_res53() * ((1 - range))))) + max_value);
	};
	return 0;
};
double RandDouble(double min_value, double max_value){
	if ((SFMT_Initialized == 0)){
		SeedRand(0);
	};
	if ((max_value > min_value)){
		return ((genrand_res53() * ((max_value - min_value))) + min_value);
	} else {
		return ((genrand_res53() * ((min_value - max_value))) + max_value);
	};
	return 0.0;
};
int64_t RandLong(int64_t min_value, int64_t max_value){
	if ((SFMT_Initialized == 0)){
		SeedRand(0);
	};
	int64_t range = (max_value - min_value);
	if ((range > 0)){
		return (((int64_t)((genrand_res53() * ((1LL + range))))) + min_value);
	} else {
		return (((int64_t)((genrand_res53() * ((1LL - range))))) + max_value);
	};
	return 0;
};
void RandomMain(){
	SFMT_Initialized = 0;
}