#include "Time.h"
#include "ClassBiTime.h"
#include "ClassBiMicroCounter.h"
#include "ClassBiMicroTimer.h"
int32_t UnixTimeStamp(){
	return time(0);
};
int32_t BiTime::SetTime(int32_t timestamp){
	if ((timestamp == -(1))){
		_time = time(0);
	} else {
		_time = timestamp;
	};
	_tm = WrappedLocaltime(_time);
	return 0;
};
int32_t BiTime::SetNames(String* names){
	return 0;
};
int32_t BiTime::Seconds(){
	return (_tm)->tm_sec;
};
int32_t BiTime::Minutes(){
	return (_tm)->tm_min;
};
int32_t BiTime::Hour(){
	return (_tm)->tm_hour;
};
int32_t BiTime::Year(){
	return ((_tm)->tm_year + 1900);
};
int32_t BiTime::MonthDay(){
	return (_tm)->tm_mday;
};
int32_t BiTime::WeekDay(){
	return (_tm)->tm_wday;
};
int32_t BiTime::YearDay(){
	return (_tm)->tm_yday;
};
int32_t BiTime::Month(){
	return ((_tm)->tm_mon + 1);
};
int32_t BiTime::isDaylightSavingTime(){
	return (_tm)->tm_isdst;
};
String* BiTime::TimeString(String* format){
	String* tmp = new String("");
	if ((format)->Contains(new String("%md"))){
		format = (format)->Replace(new String("%md"), ((new String(""))->Append((this)->MonthDay())));
	};
	if ((format)->Contains(new String("%mn"))){
		format = (format)->Replace(new String("%mn"), ((new String(""))->Append((this)->Month())));
	};
	if ((format)->Contains(new String("%h"))){
		tmp = ((new String(""))->Append((this)->Hour()));
		if (((tmp)->Length == 1)){
			tmp = (new String("0"))->Append(tmp);
		};
		format = (format)->Replace(new String("%h"), tmp);
	};
	if ((format)->Contains(new String("%m"))){
		tmp = ((new String(""))->Append((this)->Minutes()));
		if (((tmp)->Length == 1)){
			tmp = (new String("0"))->Append(tmp);
		};
		format = (format)->Replace(new String("%m"), tmp);
	};
	if ((format)->Contains(new String("%s"))){
		tmp = ((new String(""))->Append((this)->Seconds()));
		if (((tmp)->Length == 1)){
			tmp = (new String("0"))->Append(tmp);
		};
		format = (format)->Replace(new String("%s"), tmp);
	};
	if ((format)->Contains(new String("%y"))){
		format = (format)->Replace(new String("%y"), ((new String(""))->Append((this)->Year())));
	};
	return format;
};
BiTime::BiTime(){
	_tm = 0;
	_time = 0;
};
int32_t BiMicroCounter::Start(){
	if ((running == 1)){
		starttime = MicroSecs();
		running = ((char)(1));
	};
	return 0;
};
int64_t BiMicroCounter::Stop(){
	endtime = MicroSecs();
	running = ((char)(0));
	return (endtime - starttime);
};
int64_t BiMicroCounter::Query(){
	if ((running == 1)){
		return (MicroSecs() - starttime);
	} else {
		return (endtime - starttime);
	};
	return 0;
};
int32_t BiMicroCounter::Reset(){
	running = ((char)(0));
	starttime = ((int64_t)(0));
	endtime = ((int64_t)(0));
	return 0;
};
BiMicroCounter::BiMicroCounter(){
	starttime = 0;
	endtime = 0;
	running = 0;
};
int32_t BiMicroTimer::Query(){
	int64_t time = MicroSecs();
	if ((running == 1)){
		if ((((lasttick + interval)) < time)){
			int32_t times = ((int32_t)((((time - lasttick)) / interval)));
			lasttick = (lasttick + ((times * interval)));
			lastquery = time;
			return times;
		};
	};
	lastquery = time;
	return ((int32_t)(0));
};
int32_t BiMicroTimer::Wait(){
	do {
	}while (!(Query()));
	return ((int32_t)(1));
};
int32_t BiMicroTimer::Pause(){
	running = ((char)(0));
	return 0;
};
int32_t BiMicroTimer::Resume(){
	if ((running == 0)){
		running = ((char)(1));
		lasttick = MicroSecs();
		lastquery = lasttick;
	};
	return 0;
};
int64_t BiMicroTimer::lastqueried(){
	return lastquery;
};
BiMicroTimer* BiMicroTimer::Create(int64_t _interval){
	BiMicroTimer* mt = (new BiMicroTimer);
	(mt)->interval = _interval;
	(mt)->running = ((char)(1));
	(mt)->starttime = MicroSecs();
	(mt)->lastquery = (mt)->starttime;
	(mt)->lasttick = (mt)->starttime;
	return mt;
};
BiMicroTimer::BiMicroTimer(){
	interval = 0;
	starttime = 0;
	lastquery = 0;
	lasttick = 0;
	running = 0;
};
void TimeMain(){
}