
#include "Glue.h"
#include "Bismuth/Core/String/String.h"

String* CompressString(String* _source)
{
	 uLongf sizeDataCompressed  = (uLongf)(_source->Length * 1.1) + 12;
    Bytef* dataCompressed = (Bytef*)malloc( sizeDataCompressed );
   int z_result = compress(dataCompressed, &sizeDataCompressed, (const Bytef*)_source->Data, (uLong)_source->Length);
   switch( z_result )
    {
    case Z_OK:
        return new String((const char*)dataCompressed);
        break;

    case Z_MEM_ERROR:
        return new String("zlib: out of memory");
        break;

    case Z_BUF_ERROR:
        return new String("zlib: output buffer wasn't large enough!");
        break;
    }
    return new String("zlib: unknown error");
}

String* UnCompressString(String* _source)
{
	uLongf sizeDataUnCompressed  = (uLongf)(_source->Length * 1.1) + 12;
 	Bytef* dataUnCompressed = (Bytef*)malloc( sizeDataUnCompressed );
   int z_result = uncompress(dataUnCompressed, &sizeDataUnCompressed, (const Bytef*)_source->Data, (uLong)_source->Length);
	switch( z_result )
    {
    case Z_OK:
        return new String((const char*)dataUnCompressed);
        break;

    case Z_MEM_ERROR:
        return new String("zlib: out of memory");
        break;

    case Z_BUF_ERROR:
        return new String("zlib: output buffer wasn't large enough!");
        break;
    }
	return new String("zlib: unknown error");
}
