'CPP-Target

Type TCPPTarget Extends TTarget
	Method CreateProgramNode:TProgramNode()
		Return New TCPPProgramNode
	EndMethod

	Method CreateFunctionNode:TFunctionNode()
		Return New TCPPFunctionNode
	EndMethod

	Method CreateClassNode:TClassNode()
		Return New TCPPClassNode
	EndMethod

	Method CreateIfNode:TIfNode()
		Return New TCPPIfNode
	EndMethod

	Method CreateElseIfNode:TElseIfNode()
		Return New TCPPElseIfNode
	EndMethod

	Method CreateElseNode:TElseNode() 
		Return New TCPPElseNode
	EndMethod

	Method CreateWhileNode:TWhileNode() 
		Return New TCPPWhileNode
	EndMethod

	Method CreateRepeatNode:TRepeatNode() 
		Return New TCPPRepeatNode
	EndMethod

	Method CreateSelectNode:TSelectNode() 
		Return New TCPPSelectNode
	EndMethod

	Method CreateCaseNode:TCaseNode() 
		Return New TCPPCaseNode
	EndMethod

	Method CreateDefaultNode:TDefaultNode()
		Return New TCPPDefaultNode
	EndMethod
	
	Method CreateForWhileNode:TForWhileNode()
		Return New TCPPForWhileNode
	End Method

	Method CreateForNode:TForNode()
		Return New TCPPForNode
	EndMethod
	
	Method CreateExitNode:TExitNode()
		Return New TCPPExitNode
	End Method
	
	Method CreateContinueNode:TContinueNode()
		Return New TCPPContinueNode
	End Method

	Method CreateAssignmentNode:TAssignmentNode()
		Return New TCPPAssignmentNode
	EndMethod

	Method CreateReturnNode:TReturnNode()
		Return New TCPPReturnNode
	EndMethod

	Method CreateDeleteNode:TDeleteNode()
		Return New TCPPDeleteNode
	EndMethod

	Method CreateFunctionCall:TFunctionCall()
		Return New TCPPFunctionCall
	EndMethod
	
	Method CreateAddressExpression:TAddressExpression()
		Return New TCPPAddressExpression
	End Method
	
	Method CreateAutoArrayExpression:TAutoArrayExpression()
		Return New TCPPAutoArrayExpression
	End Method
	
	Method CreateNewArrayExpression:TNewArrayExpression()
		Return New TCPPNewArrayExpression
	End Method
	
	Method CreateIndexExpression:TIndexExpression()
		Return New TCPPIndexExpression
	End Method

	Method CreateTypeCastExpression:TTypeCastExpression()
		Return New TCPPTypeCastExpression
	EndMethod

	Method CreateBinaryOpExpression:TBinaryOpExpression()
		Return New TCPPBinaryOpExpression
	EndMethod

	Method CreateUnaryOpExpression:TUnaryOpExpression()
		Return New TCPPUnaryOpExpression
	EndMethod

	Method CreateGroupingExpression:TGroupingExpression() 
		Return New TCPPGroupingExpression
	EndMethod

	Method CreateMemberAccessExpression:TMemberAccessExpression()
		Return New TCPPMemberAccessExpression
	EndMethod

	Method CreateLiteralNode:TLiteralNode()
		Return New TCPPLiteralNode
	EndMethod

	Method CreateVariableNode:TVariableNode() 
		Return New TCPPVariableNode
	EndMethod

	Method CreateNewExpression:TNewExpression() 
		Return New TCPPNewExpression
	EndMethod

	Method CreateVariableDeclNode:TVariableDeclNode()
		Return New TCPPVariableDeclNode
	EndMethod

	Method CreateDatatype:TDatatype()
		Return New TCPPDatatype
	EndMethod

	Method InitFunctionTable()
		EmitProgram             = TCPPProgramNode.Emit
		EmitProgramModuleImport = TCPPProgramNode.EmitProgramModuleImport
		EmitProgramFileImport   = TCPPProgramNode.EmitProgramFileImport
		EmitProgramStatement    = TCPPProgramNode.EmitProgramStatement
		EmitProgramFunction     = TCPPProgramNode.EmitProgramFunction
		EmitProgramClass        = TCPPProgramNode.EmitProgramClass
		EmitProgramGlobal       = TCPPProgramNode.EmitProgramGlobal
		EmitProgramExtern       = TCPPProgramNode.EmitProgramExtern
		EmitFunction            = TCPPFunctionNode.Emit
		EmitClass               = TCPPClassNode.Emit
		EmitReturn              = TCPPReturnNode.Emit
		EmitDelete              = TCPPDeleteNode.Emit
		EmitExit                = TCPPExitNode.Emit
		EmitContinue            = TCPPContinueNode.Emit
		EmitIf                  = TCPPIfNode.Emit
		EmitElseIf              = TCPPElseIfNode.Emit
		EmitElse                = TCPPElseNode.Emit
		EmitWhile               = TCPPWhileNode.Emit
		EmitRepeat              = TCPPRepeatNode.Emit
		EmitSelect              = TCPPSelectNode.Emit
		EmitCase                = TCPPCaseNode.Emit
		EmitDefault             = TCPPDefaultNode.Emit
		EmitForWhile            = TCPPForWhileNode.Emit
		EmitFor                 = TCPPForNode.Emit
		EmitAssignment          = TCPPAssignmentNode.Emit
		EmitAddress             = TCPPAddressExpression.Emit
		EmitAutoArray           = TCPPAutoArrayExpression.Emit
		EmitNewArray            = TCPPNewArrayExpression.Emit
		EmitIndex               = TCPPIndexExpression.Emit
		EmitFunctionCall        = TCPPFunctionCall.Emit
		EmitBinaryOp            = TCPPBinaryOpExpression.Emit
		EmitUnaryOp             = TCPPUnaryOpExpression.Emit
		EmitGrouping            = TCPPGroupingExpression.Emit
		EmitMemberAccess        = TCPPMemberAccessExpression.Emit
		EmitNew                 = TCPPNewExpression.Emit
		ScopeVarDecl            = TCPPVariableDeclNode.ScopeVarDecl
		EmitVariableDecl        = TCPPVariableDeclNode.Emit
		EmitVariable            = TCPPVariableNode.Emit
		EmitDatatype            = TCPPDatatype.Emit
		EmitLiteral             = TCPPLiteralNode.Emit
		EmitTypeCast            = TCPPTypeCastExpression.Emit
	EndMethod
EndType

Type TCPPProgramNode Extends TProgramNode
	Method GenerateHeader(Writer:TCodeWriter)
		GenerateClassPrototypes(Writer)
		
		For Local VarDecl:TVariableDeclNode = EachIn Statements
			If VarDecl.IsExtern Then Continue
			
			Writer.BeginStatement(VarDecl)
			If VarDecl.DeclKind = KEY_GLOBAL Then 
				Writer.AddRaw("extern ")
				VarDecl.GenerateDeclaration(Writer)
			ElseIf VarDecl.DeclKind = KEY_CONST Then
				VarDecl.GenerateImplementation(Writer)
			EndIf
			Writer.EndStatement()
		Next
		
		For Local FunctionNode:TFunctionNode = EachIn Functions
			If FunctionNode.IsExtern Then Continue
			
			Writer.AddDeclaration(FunctionNode)
		Next
	EndMethod
	
	Method GenerateClassHeader(Writer:TCodeWriter, Class:TClassNode)
		GenerateClassPrototypes(Writer)
		Writer.AddDeclaration(Class)
	End Method
	
	Method GenerateClassPrototypes(Writer:TCodeWriter)
		For Local DepMap:TMap = EachIn Dependencies.Values()
			For Local Class:TCPPClassNode = EachIn DepMap.Keys()
				If Not Class.Root.IsModule Then
					Writer.BeginStatement(Class)
					Class.GeneratePrototypeCode(Writer)
					Writer.EndStatement()
				EndIf
			Next
		Next
	End Method
	
	Method TopologicalSort:TList()
		Local Queue:TList = New TList, SortedList:TList = New TList
		
		For Local Class:TCPPClassNode = EachIn Classes
			If Not Class.IsExtern Then
				Queue.AddLast(Class)
				
				Class.InDegree = 0
				For Local Parent:TClassNode = EachIn Class.ClassParents
					If (Not Parent.IsExtern) And Parent.Root = Class.Root Then Class.InDegree :+ 1
				Next
			EndIf
		Next
		
		While Not Queue.IsEmpty()
			Local WorkNode:TCPPClassNode
			For Local Node:TCPPClassNode = EachIn Queue
				If Node.InDegree = 0 Then
					WorkNode = Node
					Queue.Remove(WorkNode)
					Exit
				EndIf
			Next
			
			If Not WorkNode Then Abort("Undetected cyclic dependancy", WorkNode)
			
			SortedList.AddLast(WorkNode)
			
			For Local Child:TCPPClassNode = EachIn WorkNode.ClassChildren
				Child.InDegree :- 1
			Next
		Wend
		
		Return SortedList
	End Method

	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		For Local VarDecl:TVariableDeclNode = EachIn Statements
			If VarDecl.DeclKind = KEY_GLOBAL And (Not VarDecl.IsExtern) Then
				Writer.BeginStatement(VarDecl)
				VarDecl.GenerateDeclaration(Writer)
				Writer.AddRaw(" = ")
				VarDecl.Datatype.GenerateAutoValue(Writer)
				Writer.EndStatement()
			EndIf
		Next
		
		For Local FunctionNode:TFunctionNode = EachIn Functions
			If Not FunctionNode.IsExtern Then Writer.AddImplementation(FunctionNode)
		Next
		
		For Local Class:TClassNode = EachIn Classes
			If Not Class.IsExtern Then Writer.AddStatement(Class)
		Next
		
		GenerateMain(Writer)
	EndMethod
	
	Method GenerateMainIdentifier:String()
		Return SanitizeIdentifier(StripAll(SourceFile)) + "Main"
	End Method
	
	Method GenerateMain(Writer:TCodeWriter)
		Writer.AddIndentedRaw("void " + GenerateMainIdentifier() + "()")
		Writer.BeginScope()
		
		For Local Statement:TStatementNode = EachIn Statements
			If Statement.IsExtern Then Continue
			
			Local VarDecl:TVariableDeclNode = TVariableDeclNode(Statement)
			
			If VarDecl Then
				If VarDecl.DeclKind = KEY_GLOBAL Then
					Writer.BeginStatement(VarDecl)
					Writer.AddRaw(VarDecl.Identifier + " = ")
					
					If VarDecl.Value Then
						VarDecl.Value.GenerateCode(Writer)
					Else
						VarDecl.Datatype.GenerateAutoValue(Writer)
					EndIf
					
					Writer.EndStatement()
				ElseIf VarDecl.DeclKind <> KEY_CONST Then
					Writer.AddStatement(VarDecl)
				EndIf
			Else
				Writer.AddStatement(Statement)
			EndIf
		Next
		
		Writer.EndScope()
	EndMethod
EndType

Type TCPPFunctionNode Extends TFunctionNode
	Method GenerateDeclaration(Writer:TCodeWriter, Prefix:String = "")
		Writer.SetCurrent(Self)
		
		Writer.AddRaw(Prefix)
		ReturnDatatype.GenerateCode(Writer)
		Writer.AddRaw(" " + Identifier + "(")
		Writer.AddImplementationList(Parameters, ", ")
		Writer.AddRaw(")")
		
		If IsAbstract Then Writer.AddRaw(" = 0")
	EndMethod

	Method GenerateImplementation(Writer:TCodeWriter, Prefix:String = "")
		Writer.SetCurrent(Self)
		
		ReturnDatatype.GenerateCode(Writer)
		Writer.AddRaw(" " + Prefix + Identifier + "(")
		Writer.AddDeclarationList(Parameters, ", ")
		Writer.AddRaw(")")
		Writer.BeginScope()
		
		For Local Variable:TVariableDeclNode = EachIn Parameters
			Writer.AddLocal(Variable)
		Next
		
		Statements.GenerateCode(Writer)
		
		If Not TReturnNode(Statements.Statements.Last()) And Not ReturnDatatype.IsVoid() Then
			Writer.BeginStatement(Null)
			Writer.AddRaw("return ")
			
			If IsConstructor Then
				Writer.AddRaw("this")
			Else
				ReturnDatatype.GenerateAutoValue(Writer)
			EndIf
			
			Writer.EndStatement()
		EndIf
		
		Writer.EndScope()
	EndMethod
	
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
	EndMethod
EndType

Type TCPPClassNode Extends TClassNode
	Field InDegree:Int

	Method GeneratePrototypeCode(Writer:TCodeWriter)
		Writer.SetCurrent(Self)
		Writer.AddRaw("struct " + Identifier)
	EndMethod
	
	Method GenerateDeclaration(Writer:TCodeWriter, Prefix:String = "")
		Writer.SetCurrent(Self)
		Writer.AddRaw("struct " + Identifier )
		
		If Not ClassParents.IsEmpty() Then
			Writer.AddRaw(": ")
			
			For Local Class:TClassNode = EachIn ClassParents
				Writer.AddRaw("public " + Class.Identifier)
				If Class <> ClassParents.Last() Then Writer.AddRaw(", ")
			Next
		EndIf
		
		Writer.BeginScope()
		
		For Local Variable:TVariableDeclNode = EachIn Variables
			If Variable.DeclKind = KEY_GLOBAL Or Variable.DeclKind = KEY_CONST Then
				Writer.BeginStatement(Variable)
				Writer.AddRaw("static ")
				Variable.GenerateDeclaration(Writer)
				Writer.EndStatement()
			Else
				Writer.AddDeclaration(Variable)
			EndIf
		Next
		
		If Constructor Then Writer.AddDeclaration(Constructor)
		
		For Local FunctionNode:TFunctionNode = EachIn Methods
			Writer.AddDeclaration(FunctionNode, "virtual ")
		Next
		
		For Local FunctionNode:TFunctionNode = EachIn Functions
			Writer.AddDeclaration(FunctionNode, "static ")
		Next
		
		Writer.AddStatementRaw(Identifier + "()")
		
		Writer.EndScope()
	EndMethod
	
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		Writer.BeginInvisibleScope()
		
		Local Accessor:String = Identifier + "::"
		
		For Local Variable:TVariableDeclNode = EachIn Variables
			If Variable.DeclKind = KEY_FIELD Then Writer.AddLocal(Variable) 'TODO
			
			If Variable.Value Then
				Writer.AddImplementation(Variable, Accessor)
			ElseIf Variable.DeclKind = KEY_GLOBAL Then
				Writer.BeginStatement(Variable)
				Variable.GenerateDeclaration(Writer, Accessor)
				Writer.AddRaw(" = ")
				Variable.Datatype.GenerateAutoValue(Writer)
				Writer.EndStatement()
			EndIf
		Next
		
		For Local FunctionNode:TFunctionNode = EachIn Methods
			If Not FunctionNode.IsAbstract Then Writer.AddImplementation(FunctionNode, Accessor)
		Next
		
		If Constructor Then Writer.AddImplementation(Constructor, Accessor)
		
		For Local FunctionNode:TFunctionNode = EachIn Functions
			If Not FunctionNode.IsAbstract Then Writer.AddImplementation(FunctionNode, Accessor)
		Next
		
		Writer.AddIndentedRaw(Accessor + Identifier + "()")
		Writer.BeginScope()
		
		For Local Variable:TVariableDeclNode = EachIn Variables
			If Variable.DeclKind = KEY_FIELD Then
				Writer.BeginStatement(Variable)
				Writer.AddRaw(Variable.Identifier + " = ")
				Variable.Datatype.GenerateAutoValue(Writer)
				Writer.EndStatement()
			EndIf
		Next
		
		Writer.EndScope()
		Writer.EndInvisibleScope()
	EndMethod
EndType

Type TCPPIfNode Extends TIfNode
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		
		Writer.AddRaw("if (")
		Expression.GenerateCode(Writer)
		Writer.AddRaw(")")
		Writer.BeginScope()
		Statements.GenerateCode(Writer)
		Writer.EndScope()
		Writer.AddList(ElseIfList, "")
		If ElseBranch Then ElseBranch.GenerateCode(Writer)
	EndMethod
EndType

Type TCPPElseIfNode Extends TElseIfNode
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		
		Writer.AddRaw(" else if (")
		Expression.GenerateCode(Writer)
		Writer.AddRaw(")")
		Writer.BeginScope()
		Statements.GenerateCode(Writer)
		Writer.EndScope()
	End Method
EndType

Type TCPPElseNode Extends TElseNode
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		
		Writer.AddRaw(" else ")
		Writer.BeginScope()
		Statements.GenerateCode(Writer)
		Writer.EndScope()
	End Method
EndType

Type TCPPWhileNode Extends TWhileNode
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		
		Writer.AddRaw("while (")
		Expression.GenerateCode(Writer)
		Writer.AddRaw(")")
		Writer.BeginScope()
		Statements.GenerateCode(Writer)
		Writer.EndScope()
	EndMethod
EndType

Type TCPPRepeatNode Extends TRepeatNode
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		
		Writer.AddRaw("do ")
		Writer.BeginScope()
		Statements.GenerateCode(Writer)
		Writer.EndScope()
			
		If Expression Then
			Writer.AddRaw("while (!(")
			Expression.GenerateCode(Writer)
			Writer.AddRaw("))")
		Else
			Writer.AddRaw("while(1)")
		EndIf
	EndMethod
EndType

Type TCPPSelectNode Extends TSelectNode
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		
		Writer.AddRaw("switch (")
		Expression.GenerateCode(Writer)
		Writer.AddRaw(")")
		Writer.BeginScope()
		
		For Local CaseNode:TCaseNode = EachIn CaseList
			CaseNode.GenerateCode(Writer)
			Writer.AddNewline()
		Next
		
		If DefaultCase Then
			DefaultCase.GenerateCode(Writer)
			Writer.AddNewline()
		EndIf
		
		Writer.EndScope()
	EndMethod
EndType

Type TCPPCaseNode Extends TCaseNode
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		
		Writer.AddIndentedRaw("case ")
		Expression.GenerateCode(Writer)
		Writer.AddRaw(":")
		Writer.AddNewline()
		
		Statements.GenerateCode(Writer)
		Writer.AddStatementRaw("break")
	EndMethod
EndType

Type TCPPDefaultNode Extends TDefaultNode
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		
		Writer.AddIndentedRaw("default:")
		Writer.AddNewline()
		Statements.GenerateCode(Writer)
	EndMethod
EndType

Type TCPPForWhileNode Extends TForWhileNode
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		
		Writer.BeginScope()
		ForStatements.GenerateCode(Writer)
		Writer.BeginStatement(Self)
		Writer.AddRaw("while (")
		WhileExpression.GenerateCode(Writer)
		Writer.AddRaw(")")
		Writer.BeginScope()
		Statements.GenerateCode(Writer)
		Writer.EndScope()
		Writer.EndStatement()
		Writer.EndScope()
	End Method
End Type

Type TCPPForNode Extends TForNode
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		
		Writer.AddRaw("for (")
		LoopVariable.GenerateCode(Writer)
		
		If Not DefineVariable Then
			Writer.AddRaw(" = ")
			FromExpression.GenerateCode(Writer)
		EndIf
		
		Writer.AddRaw("; ")
		Variable.GenerateCode(Writer)
		
		If StepExpression Then
			StepExpression.EvaluateResult()
			
			Local StepString:String = StepExpression.GetCastedStringResult()
			If SkipLast Then Writer.AddRaw(" + " + StepString)
			
			Local Interleavings:String[]
			If StepExpression.GetCastedDoubleResult() >= 0 Then
				Interleavings = [" <= ", " += " + StepString]
			Else
				Interleavings = [" >= ", " -= " + StepString[1 ..]]
			EndIf
			
			Writer.AddRaw(Interleavings[0])
			ToExpression.GenerateCode(Writer)
			Writer.AddRaw("; ")
			Variable.GenerateCode(Writer)
			Writer.AddRaw(Interleavings[1])
		Else
			If SkipLast Then Writer.AddRaw(" < ") Else Writer.AddRaw(" <= ")
			
			ToExpression.GenerateCode(Writer)
			Writer.AddRaw("; ")
			Variable.GenerateCode(Writer)
			Writer.AddRaw(" += 1")
		EndIf
		
		Writer.AddRaw(")")
		Writer.BeginScope()
		Statements.GenerateCode(Writer)
		Writer.EndScope()
	EndMethod
EndType

Type TCPPExitNode Extends TExitNode
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		Writer.AddRaw("break")
	End Method
End Type

Type TCPPContinueNode Extends TContinueNode
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		Writer.AddRaw("continue")
	End Method
End Type

Type TCPPAssignmentNode Extends TAssignmentNode
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		
		LeftExp.GenerateCode(Writer)
		Writer.AddRaw(" = ")
		RightExp.GenerateCode(Writer)
	EndMethod
EndType

Type TCPPReturnNode Extends TReturnNode
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		
		Writer.AddRaw("return ")
		If TargetExp Then TargetExp.GenerateCode(Writer)
	EndMethod
EndType

Type TCPPDeleteNode Extends TDeleteNode
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		
		Writer.AddRaw("delete ")
		TargetExp.GenerateCode(Writer)
	End Method
EndType

Type TCPPAddressExpression Extends TAddressExpression
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		
		Writer.AddRaw("(&")
		TargetExp.GenerateCode(Writer)
		Writer.AddRaw(")")
	End Method
End Type

Type TCPPAutoArrayExpression Extends TAutoArrayExpression
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		
		Writer.AddRaw("(new Array<")
		Datatype.NestedType.GenerateCode(Writer)
		Writer.AddRaw(", 1>(" + Values.Length + ", ")
		Writer.AddArray(Values, ", ")
		Writer.AddRaw("))")
	End Method
End Type

Type TCPPNewArrayExpression Extends TNewArrayExpression
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		
		Writer.AddRaw("(new Array<")
		Datatype.NestedType.GenerateCode(Writer)
		Writer.AddRaw(", " + Sizes.Length + ">(-1, ")
		Writer.AddArray(Sizes, ", ")
		Writer.AddRaw("))")
	End Method
End Type

Type TCPPIndexExpression Extends TIndexExpression
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		
		If IsArray Then
			Writer.AddRaw("(*")
			TargetExp.GenerateCode(Writer)
			Writer.AddRaw("->At(")
			Writer.AddArray(Indices, ", ")
			Writer.AddRaw("))")
		Else
			Writer.AddRaw("(")
			TargetExp.GenerateCode(Writer)
			Writer.AddRaw("[")
			Indices[0].GenerateCode(Writer)
			Writer.AddRaw("])")
		EndIf
	End Method
End Type

Type TCPPFunctionCall Extends TFunctionCall
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		
		TargetExp.GenerateCode(Writer)
		Writer.AddRaw("(")
		Writer.AddList(Parameters, ", ")
		Writer.AddRaw(")")
	EndMethod
EndType

Type TCPPTypeCastExpression Extends TTypeCastExpression
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		
		Local TargetType:TDatatype = TargetExp.EvaluateDatatype()
		
		If Datatype.IsUnequal(TargetType) Then
			If Datatype.IsBoolean() Then
				Writer.AddRaw("(")
				Writer.AddBracketed(TargetExp)
				
				If TargetType.IsString() Or TargetType.IsArray() Then
					Writer.AddRaw("->Length)")
				ElseIf TargetType.IsCompound() Then
					Writer.AddRaw(" != NULL)")
				Else
					Writer.AddRaw(")")
				EndIf
			ElseIf Datatype.IsString() And TargetType.IsPrimitive() Then
				Writer.AddRaw("((new String(~q~q))->Append")
				Writer.AddBracketed(TargetExp)
				Writer.AddRaw(")")
			ElseIf Datatype.IsCompound() Then
				If TargetType.IsCompound() And TargetType.Compound.HasParent(Datatype.Compound) Then
					Writer.AddBracketed(TargetExp)
				Else
					Writer.AddRaw("(dynamic_cast<")
					Datatype.GenerateCode(Writer)
					Writer.AddRaw(">")
					Writer.AddBracketed(TargetExp)
					Writer.AddRaw(")")
				EndIf
			ElseIf Datatype.IsPointer() And Datatype.NestedType.TypeKind = TYPE_BYTE And TargetType.IsString() Then
				Writer.AddRaw("(")
				Writer.AddBracketed(TargetExp)
				Writer.AddRaw("->Data)")
			Else
				Writer.AddRaw("(")
				Writer.AddBracketed(Datatype)
				Writer.AddBracketed(TargetExp)
				Writer.AddRaw(")")
			EndIf
		Else
			Writer.AddBracketed(TargetExp)
		EndIf
	EndMethod
EndType

Type TCPPBinaryOpExpression Extends TBinaryOpExpression
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		
		Local LeftType:TDatatype  = LeftExp .EvaluateDatatype()
		Local RightType:TDatatype = RightExp.EvaluateDatatype()
		
		If LeftType.IsNumeric() And RightType.IsNumeric() And Operator = TOK_CARET Then
			Writer.AddRaw("PowerOf(")
			Writer.AddArray([LeftExp, RightExp], ", ")
			Writer.AddRaw(")")
		ElseIf Operator = TOK_EQUAL And (LeftType.IsString() Or RightType.IsString()) Then
			Writer.AddBracketed(LeftExp)
			Writer.AddRaw("->Equals")
			Writer.AddBracketed(RightExp)
		ElseIf LeftType.IsString() Then
			Writer.AddBracketed(LeftExp)
			Writer.AddRaw("->Append")
			Writer.AddBracketed(RightExp)
		ElseIf RightType.IsString() Then
			Writer.AddBracketed(RightExp)
			Writer.AddRaw("->Prepend")
			Writer.AddBracketed(LeftExp)
		Else
			Writer.AddRaw("(")
			LeftExp.GenerateCode(Writer)
			Writer.AddRaw(" " + OperatorToCode() + " ")
			RightExp.GenerateCode(Writer)
			Writer.AddRaw(")")
		EndIf
	EndMethod

	Method OperatorToCode:String()
		Select Operator
			Case TOK_PLUS, TOK_MINUS, TOK_ASTERISK, TOK_SLASH, TOK_AMPERSAND, TOK_PIPE, TOK_SMALLEREQUAL, TOK_GREATEREQUAL, TOK_SMALLER, TOK_GREATER
				Return TLexer.TokenToString(Operator)
			Case KEY_MOD
				Return "%"
			Case KEY_AND
				Return "&&"
			Case KEY_OR
				Return "||"
			Case TOK_TILDE
				Return "^"
			Case KEY_SHL
				Return "<<"
			Case KEY_SHR
				Return ">>"
			Case TOK_EQUAL
				Return "=="
			Case TOK_UNEQUAL
				Return "!="
		End Select
	End Method
EndType

Type TCPPUnaryOpExpression Extends TUnaryOpExpression
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		
		Select Operator
			Case TOK_MINUS
				Writer.AddRaw("-")
			Case TOK_TILDE
				Writer.AddRaw("~~")
			Case KEY_NOT
				Writer.AddRaw("!")
		End Select
		
		Writer.AddBracketed(TargetExp)
	EndMethod
EndType

Type TCPPGroupingExpression Extends TGroupingExpression
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		Writer.AddBracketed(TargetExp)
	EndMethod
EndType

Type TCPPMemberAccessExpression Extends TMemberAccessExpression
	 Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		
		Local Literal:TLiteralNode = TLiteralNode(TargetExp)
		
		If IsStaticAccess Or (Literal And Literal.LiteralKind = KEY_SUPER) Then
			Writer.AddRaw(TargetClass.Identifier + "::" + Identifier)
		Else
			Writer.AddBracketed(TargetExp)
			Writer.AddRaw("->" + Identifier)
		EndIf
	End Method
EndType

Type TCPPLiteralNode Extends TLiteralNode
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		
		Select LiteralKind
			Case KEY_TRUE
				Writer.AddRaw("1")
			Case KEY_FALSE
				Writer.AddRaw("0")
			Case TOK_BYTE, TOK_SHORT, TOK_INT
				Writer.AddRaw(String.FromLong(IntValue))
			Case TOK_LONG
				Writer.AddRaw(String.FromLong(IntValue) + "LL")
			Case TOK_FLOAT
				Writer.AddRaw(String.FromFloat(FloatValue) + "f")
			Case TOK_DOUBLE
				Writer.AddRaw(String.FromDouble(DoubleValue))
			Case TOK_STRING
				Local Sanitized:String = StringValue
				For Local I:String[] = EachIn [["\", "\\"], ["~n", "\n"], ["~r", "\r"], ["~t", "\t"], ["~q", "\~q"]]
					Sanitized = Sanitized.Replace(I[0], I[1])
				Next
				
				Writer.AddRaw("new String(~q" + Sanitized + "~q)")
			Case TOK_UBYTE, TOK_USHORT, TOK_UINT
				Writer.AddRaw(String.FromLong(IntValue) + "U")
			Case TOK_ULONG
				Writer.AddRaw(String.FromLong(IntValue) + "ULL")
			Case KEY_NULL
				Writer.AddRaw("0") 'TODO: Cast to suitable candidates
			Case KEY_SELF
				Writer.AddRaw("this")
		End Select
	EndMethod
EndType

Type TCPPVariableNode Extends TVariableNode
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		Writer.AddRaw(Origin.Identifier)
	EndMethod
EndType

Type TCPPNewExpression Extends TNewExpression
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		Writer.AddRaw("(new " + TargetClass.Identifier + ")")
	End Method
EndType

Type TCPPVariableDeclNode Extends TVariableDeclNode
	Method GenerateDeclaration(Writer:TCodeWriter, Prefix:String = "")
		Writer.SetCurrent(Self)
		
		If DeclKind = KEY_CONST Then Writer.AddRaw("const ")
		
		Datatype.GenerateCode(Writer, Prefix + Identifier)
		
		If Not Datatype.IsFunction() Then Writer.AddRaw(" " + Prefix + Identifier)
	EndMethod
	
	Method GenerateImplementation(Writer:TCodeWriter, Prefix:String = "")
		GenerateDeclaration(Writer, Prefix)
		
		If Value Then
			Writer.AddRaw(" = ")
			Value.GenerateCode(Writer)
		EndIf
	EndMethod
	
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		GenerateDeclaration(Writer)
		Writer.AddRaw(" = ")
		
		If Value Then
			Value.GenerateCode(Writer)
		Else
			Datatype.GenerateAutoValue(Writer)
		EndIf
		
		If DeclKind = KEY_LOCAL Then Writer.AddLocal(Self)
	EndMethod
EndType

Type TCPPDatatype Extends TDatatype
	Method GenerateAutoValue(Writer:TCodeWriter)
		Writer.SetCurrent(Self)
		
		Select TypeKind
			Case TYPE_BOOL, TYPE_BYTE, TYPE_SHORT, TYPE_INT, TYPE_LONG, TYPE_POINTER
				Writer.AddRaw("0")
			Case TYPE_FLOAT
				Writer.AddRaw("0.0f")
			Case TYPE_DOUBLE
				Writer.AddRaw("0.0")
			Case TYPE_STRING
				Writer.AddRaw("new String(~q~q)")
			Case TYPE_ARRAY
				Writer.AddRaw("new Array<")
				NestedType.GenerateCode(Writer)
				Writer.AddRaw(", " + Dimension + ">(0)")
			Case TYPE_COMPOUND
				Writer.AddRaw("0")
			Case TYPE_FUNCTION
				Writer.AddRaw("0")
			Case TYPE_ANY, TYPE_VOID
				Abort("Wtf man it doesn't work that way", Self)
		End Select
	EndMethod
	
	Method GenerateCode(Writer:TCodeWriter, Data:Object = Null)
		Writer.SetCurrent(Self)
		
		If IsUnsigned Then Writer.AddRaw("u")
		Select TypeKind
			Case TYPE_VOID
				Writer.AddRaw("void")
			Case TYPE_BOOL
				Writer.AddRaw("bool")
			Case TYPE_BYTE
				If IsUnsigned Then
					Writer.AddRaw("int8_t")
				Else
					Writer.AddRaw("char")
				EndIf
			Case TYPE_SHORT
				Writer.AddRaw("int16_t")
			Case TYPE_INT
				Writer.AddRaw("int32_t")
			Case TYPE_LONG
				Writer.AddRaw("int64_t")
			Case TYPE_FLOAT
				Writer.AddRaw("float")
			Case TYPE_DOUBLE
				Writer.AddRaw("double")
			Case TYPE_STRING
				Writer.AddRaw("String*")
			Case TYPE_COMPOUND
				Writer.AddRaw(Compound.Identifier + "*")
			Case TYPE_POINTER
				NestedType.GenerateCode(Writer)
				Writer.AddRaw("*")
			Case TYPE_ARRAY
				Writer.AddRaw("Array<")
				NestedType.GenerateCode(Writer)
				Writer.AddRaw(", " + Dimension + ">*")
			Case TYPE_FUNCTION
				ReturnType.GenerateCode(Writer)
				
				Writer.AddRaw(" (*" + String(Data) + ") (")
				Writer.AddArray(Parameters, ", ")
				Writer.AddRaw(")")
			Case TYPE_ANY
				Abort("Wtf man it doesn't work that way", Self)
		End Select
	EndMethod
EndType